package com.tofly.security.component.exception;

import com.fasterxml.jackson.annotation.JsonFormat;

@JsonFormat(shape = JsonFormat.Shape.OBJECT)
public enum ErrorMessage {
  // ERROR STARTS FROM HERE
  INTERNAL_ERROR(500000, "网络异常"),
  TB_ERR(00000, "TB业务错误"),
  INTERNAL_ERR(00000, "系统异常"),
  OPERATION_FAILED(500001, "操作失败"),
  NO_PERMISSION(403001, "没有操作权限"),
  ACCOUNT_DISABLED(403002, "账号已禁用"),
  ACCESS_DENIED(403003, "拒绝访问"),
  AUTHENTICATION_METHOD_NOT_SUPPORTED(403004, "权限认证失败"),
  ACCOUNT_LOCKED(403005, "根据相关安全策略账号已锁定！"),
  NOT_HAVE_PERMISSION(403006, "您没有执行该操作的权限!"),
  ACCOUNT_IS_NOT_ACTIVE(401000,"用户账号未激活或初始密码未修改"),
  USERNAME_PASSWORD_INCORRECT(401001, "用户名或密码错误"),

  VERIFICATION_CODE_INCORRECT(402001, "验证码错误"),
  TOKEN_EXPIRED(401002, "token已过期，请重新登录"),
  NONE_TENANT_ASSET(401003, "非当前租户资产"),
  BAD_PARAMETER(400000, "查询参数无效"),
  INVALID_PARAMETER(400001, "无效参数"),
  TOO_MANY_REQUEST(429001, "请求过多"),
  EXIST_ENABLE_TEMPLATE(400002,"存在已启用相同类型及用途的模板"),
  NOT_SET_PASSWORD_TEMPLATE(400003,"未设置用于密码重置的模板"),
  PROVIDE_CORRECT_PHONE_NUMBER(400004,"请提供正确的电话号码"),
  PROVIDE_CORRECT_EMAIL(400005,"请提供正确的邮箱"),
  PHONE_NUMBER_OR_EMAIL_REQUIRED(400006,"必须提供电话或者邮箱"),
  NAME_ALREADY_EXISTS(400007,"名称已被使用"),
  ROLE_IN_USE(400008,"该角色还存在用户使用"),
  NONE_DEFAULT_RULE_CHAIN(400009,"该租户不存在默认的规则链"),
  TENANT_MISMATCHING(400010,"租户不匹配"),
  GET_CURRENT_USER_EXCEPTION(400011,"获取当前用户信息异常"),
  SEND_DESTINATION_NOT_FOUND(400012,"通知失败！找不到发送目标"),
  USER_NAME_ALREADY_EXISTS(400013,"用户名已存在"),
  DATA_ALREADY_EXISTS(400014,"数据已存在,无需重复操作"),
  USER_NOT_EXISTS(400015,"用户不存在"),
  ENABLED_CONFIG_IS_EXISTED(400016,"已启用同类型配置"),
  USERNAME_IS_IMMUTABLE(400017,"用户账号不可变"),
  MESSAGE_CONFIG_NOT_EXISTS(400018,"消息配置不存在或未启用"),
  IT_CANT_EQUAL_ITSELF(400019,"父级组织不可以为本身"),
  MESSAGE_TEMPLATE_NOT_EXISTS(400020,"消息模板不存在或未启用！"),
  DEVICE_NOT_EXISTENCE_IN_TENANT(400021,"当前租户下不存在该设备"),
  DEVICE_RELATION_IS_ABSENT(400022,"设备关联关系已不存在"),
  DATA_IS_DELETED(400023,"数据已经删除"),
  CONVERT_JS_IS_ALONE(400024,"转换脚本只能启用一个"),
  PHONE_OR_EMAIL_HAS_REGISTER(400025,"手机或邮箱已被使用"),
  CONTACT_ALREADY_ASSOCIATED(400026,"当前联系人已与告警配置【%s】关联"),
  MSG_CODE_NOT_MATCHED(400027,"验证码不正确"),
  ACCOUNT_HAS_EXPIRED(400028,"账号已过期,请联系管理员"),
  ORGANIZATION_NOT_EXTIED(400029,"组织不存在"),
  ORGANIZATION_DEVICE_NOT_MATCHED_IN_TRIGGER(400030,"触发器中存在设备不属于场景联动所在组织"),
  ORGANIZATION_DEVICE_NOT_MATCHED_IN_CONDITION(400031,"执行条件中存在设备不属于场景联动所在组织"),
  ORGANIZATION_DEVICE_NOT_MATCHED_IN_ACTION(400032,"动作中存在设备不属于场景联动所在组织"),
  ORGANIZATION_EXISTED_SCENE_REACT(400033,"组织被场景联动使用中"),
  ORGANIZATION_EXISTED_ALARM_CONTACT(400034,"组织被告警联系人使用中"),
  EXIST_LEADER_MEMBER_RELATION(400035,"删除字典前，请先清空字典值。"),
  VIDEO_PLATFORM_USED(400035,"存在使用该视频流配置的视频"),
  NOT_EXITED_OR_PERMISSION(400036,"【%s】没有修改权限或不存在"),
  FILE_NOT_FOUND(400036,"文件未找到"),
  STORE_FILE_FAILED(400037,"文件存储失败"),
  NOT_BELONG_CURRENT_TENANT(400038,"该数据不属于当前租户"),
  DEVICE_LOSED(400039,"设备相关参数丢失"),
  SCENE_REACT_NOT_EXTIED(400040,"场景联动不存在"),
  DEVICE_USED_SCENE_REACT(400041,"场景联动【%s】正在使用该设备"),
  SCENE_REACT_USED_ALARM_PROFILE(400042,"场景联动【%s】正在使用该告警配置"),
  APP_USER_BINDED(400043,"平台用户【%s】已被其它账号绑定"),
  THIRD_PLATFORM_EXCEPTION(400044,"【%s】，第三方异常【%s】"),
  DEVICE_NOT_EXTIED(400045,"设备不存在"),
  VIDEO_PLATFORM_HOST_EXISTED(400046,"流媒体平台地址已存在"),
  VIDEO_PLATFORM_CONFIG_LACK(400047,"流媒体平台信息缺失"),
  VIDEO_PLATFORM_CONFIG_ERROR(400048,"流媒体平台信息配置有误"),
  VIDEO_PLATFORM_NEED_ENABLE_HLS_HTTPS(400049,"平台需开启https的hls协议"),
  NAME_EXISTED(400050,"名称【%s】已被使用"),
  INVALID_PARAMETER_OR_NOT_MATCH_TENANT(400051,"参数错误或该条数据不属于当前租户"),
  CRON_INVALID(400052,"cron表达式无效"),
  EXPORT_CONFIG_NON_EXISTENT(400053,"报表配置不存在或已被删除"),
  START_TIME_NOT_MORE_THAN_END_TIME(400054,"开始时间不能大于结束时间"),
  START_TIME_OR_END_TIME_EXCEPTION(400055,"开始时间或结束时间异常"),
  TARGET_TEMPLATE_NOT_EXISTS_SELF_NOTICE(400056,"密码重置成功，请自行通知用户！"),
  ASSERT_DEFAULT_NAME_NO_CHANGED(400056,"系统预制资源，不能修改名称！"),
  DATA_BOARD_IS_PRIVATE(400057,"该数据看板不是公有视图"),
  MESSAGE_SEND_TOO_FAST(400058,"1分钟内请求次数过多，请休息一下！"),
  PASSWORD_INCORRECT(4010059, "密码错误!"),
  MESSAGE_SEND_FAILED(4010060, "消息发送失败!"),
  PROJECT_USED_SCRIPT(400061,"产品【%s】正在使用待删除的解析脚本"),
  RULE_CHAIN_NOT_ENABLE(400062,"规则链不是有效的！"),
  DUPLICATE_IDENTIFIERS_EXIST(400063,"存在重复的功能标识符。"),
  SMS_CONFIG_ERROR(400064,"短信配置错误。"),
  INVALID_TOPIC(400065,"无效Topic。"),
  HAVE_NO_PERMISSION(500002,"没有修改权限");
  private final int code;
  private String message;

  ErrorMessage(int code, String message) {
    this.code = code;
    this.message = message;
  }

  public ErrorMessage setMessage(String message) {
    this.message = message;
    return this;
  }

  public int getCode() {
    return code;
  }

  public String getMessage() {
    return message;
  }
}
