package com.tofly.security.component.exception;

import lombok.Getter;
import org.springframework.http.HttpStatus;

public class ThingsKitException extends RuntimeException {
  private static final long serialVersionUID = 4036257507478854844L;

  @Getter private final HttpStatus httpStatus;

  @Getter private final ErrorMessage error;


  public ThingsKitException(ErrorMessage errorMessage) {
    super(errorMessage.getMessage());
    this.httpStatus = HttpStatus.BAD_REQUEST;
    this.error = errorMessage;
  }

  public ThingsKitException(ErrorMessage errorMessage, HttpStatus httpStatus) {
    super(errorMessage.getMessage());
    this.httpStatus = httpStatus;
    this.error = errorMessage;
  }

  public ThingsKitException() {
    super(ErrorMessage.INTERNAL_ERROR.getMessage());
    this.error = ErrorMessage.INTERNAL_ERROR;
    this.httpStatus = HttpStatus.INTERNAL_SERVER_ERROR;
  }
}
