package com.tofly.security.id;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

@EqualsAndHashCode(callSuper = false)
@Data
public class TenantDTO extends BaseDTO {
  private String name;

  private String icon;

  private boolean enabled;

  private String description;

  private String defaultConfig;

  private String tenantId;

  private String[] roleIds;

  @JsonInclude(JsonInclude.Include.NON_NULL)
  private TenantStatusEnum tenantStatus;

  @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
  @JsonSerialize(using = LocalDateTimeSerializer.class)
  private LocalDateTime tenantExpireTime;

  private String tenantProfileId;
}
