package com.tofly.security.id;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotEmpty;
import java.util.Date;
import java.util.Set;

@EqualsAndHashCode(callSuper = false)
@Data
public class UserDTO extends BaseDTO {

  private String username;

  private String realName;

  private transient String password;

  private String activateToken;

  private String customerId;

  private String[] organizationIds;

  private String[] roleIds;

  private String phoneNumber;

  private String email;

  private String avatar;

  private String tbUser;

  private boolean enabled;

  @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
  private Date accountExpireTime;

  private boolean hasPassword;

  private String tenantId;

  private String tenantName;

  private UserStatusEnum userStatusEnum;

  private Set<PlainRolesDTO> roles;

  private Integer level;

  private String remark;

  private Boolean locked;

  private Integer isFirst;
  
  
  
}
