package com.tofly.base.config;

import lombok.AllArgsConstructor;
import lombok.Getter;
import org.springframework.util.StringUtils;

@Getter
@AllArgsConstructor
public enum FileTableEnum {
    Sys_Dict("Sys_Dict", "SysDictService"),

    Sys_Dict_Item("Sys_Dict_Item", "SysDictItemService"),

    ;
    /**
     * 内容
     */
    private String tableName;

    /**
     * 注入服务名称
     */
    private String injectionServerType;

    public static String getCodeForValue(String tableName) {
        String path = "";
        if (StringUtils.isEmpty(tableName)) {
            return path;
        }

        for (FileTableEnum e : FileTableEnum.values()) {
            if (e.tableName.equalsIgnoreCase(tableName)) {
                path = e.injectionServerType;
                break;
            }
        }
        return path;
    }
}
