package com.tofly.base.config;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.tofly.base.server.common.data.constant.ModelConstants;
import com.tofly.base.utils.UserTokenUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
@Slf4j
public class MyMetaObjectHandler implements MetaObjectHandler {

    @Override
    public void insertFill(MetaObject metaObject) {
        String userid = UserTokenUtil.getTokenUserID();
        //创建时间
        this.setFieldValByName(ModelConstants.TablePropertyMapping.CREATE_TIME, new Date(), metaObject);
        this.setFieldValByName(ModelConstants.TablePropertyMapping.CREATE_DATE, new Date(), metaObject);
        //修改时间
        this.setFieldValByName(ModelConstants.TablePropertyMapping.UPDATE_TIME, new Date(), metaObject);
        //创建人
        this.setFieldValByName(ModelConstants.TablePropertyMapping.CREATOR, userid, metaObject);
        this.setFieldValByName(ModelConstants.TablePropertyMapping.CREATE_USER, userid, metaObject);
        //修改人
        this.setFieldValByName(ModelConstants.TablePropertyMapping.UPDATER, userid, metaObject);
        this.setFieldValByName(ModelConstants.TablePropertyMapping.DELETED, 0, metaObject);
    }

    @Override
    public void updateFill(MetaObject metaObject) {
        String userid = UserTokenUtil.getTokenUserID();
        //修改时间
        this.setFieldValByName(ModelConstants.TablePropertyMapping.UPDATE_TIME, new Date(), metaObject);
        //修改人
        this.setFieldValByName(ModelConstants.TablePropertyMapping.UPDATER, userid, metaObject);
        this.setFieldValByName(ModelConstants.TablePropertyMapping.UPDATEUSER, userid, metaObject);

    }
}
