package com.tofly.base.controller.area;
import com.tofly.base.server.common.data.dto.SysAreaDTO;
import com.tofly.base.service.area.SysAreaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author: 徐浩然
 * @desc: 中国省市区街关联
 * @date: 2021/12/3-15:56
 */
@Api(tags = "中国省市区街关联")
@RestController
@RequestMapping("api/yt/area")
@RequiredArgsConstructor
public class TkAreaController {
  private final SysAreaService sysAreaService;

  @PostMapping("list")
  @ApiOperation("查询")
  public ResponseEntity<List<SysAreaDTO>> areaList(@RequestBody SysAreaDTO sysAreaDTO) {
    return ResponseEntity.ok(sysAreaService.list(sysAreaDTO));
  }
}
