//package com.tofly.base.controller.tenant;
//
//import org.springframework.context.ApplicationEventPublisher;
//import org.springframework.security.access.prepost.PreAuthorize;
//import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
//import org.springframework.web.bind.annotation.*;
//
//import com.tofly.base.controller.AbstractUserAccount;
//import com.tofly.base.server.common.data.core.exception.ThingsboardException;
//import com.tofly.base.server.common.data.core.exception.TkDataValidationException;
//import com.tofly.base.server.common.data.core.message.ErrorMessage;
//import com.tofly.base.server.common.data.dto.UserDTO;
//import com.tofly.base.server.common.data.id.TenantId;
//import com.tofly.base.server.common.data.id.UserId;
//import com.tofly.base.server.common.data.security.SecurityUser;
//import com.tofly.base.server.utils.AccountProperties;
//import com.tofly.base.service.security.system.SystemSecurityService;
//import com.tofly.base.service.user.TkUserService;
//import com.tofly.base.service.user.UserService;
//
//import java.util.UUID;
//
//@RestController
//@RequestMapping("/api/yt/tenant")
//public class TkTenantController extends AbstractUserAccount {
//
//  private final TkUserService userService;
//  private final AccountProperties accountProperties;
//  public TkTenantController(UserService tbUserService, ApplicationEventPublisher eventPublisher,
//                            SystemSecurityService systemSecurityService,
//                            BCryptPasswordEncoder passwordEncoder,
//                            TkUserService userService,
//                            AccountProperties accountProperties) {
//    super(tbUserService,eventPublisher,systemSecurityService,passwordEncoder);
//    this.userService = userService;
//    this.accountProperties = accountProperties;
//  }
//
//  @PostMapping("/reset_password/{userId}")
//  @PreAuthorize("hasAnyAuthority('SYS_ADMIN','PLATFORM_ADMIN')")
//  public void resetPassword(@PathVariable("userId") String userId) throws ThingsboardException {
//    //check is tenant account
//    UserDTO userDTO = userService.checkAccount(userId,2);
//    if(null == userDTO){
//      throw new TkDataValidationException(ErrorMessage.INVALID_PARAMETER.getMessage());
//    }
//    //update
//    String resetPassword = accountProperties.getDefaultPassword();
//    SecurityUser securityUser = new SecurityUser();
//    securityUser.setId(new UserId(UUID.fromString(userDTO.getTbUser())));
//    securityUser.setTenantId(TenantId.fromUUID(UUID.fromString(userDTO.getTenantId())));
//    updatePassword(resetPassword,securityUser);
//    userService.resetPassword(userId, getCurrentUser().getCurrentTenantId(),resetPassword);
//    SendResetPasswordEmailMsg msg = new SendResetPasswordEmailMsg();
//    msg.setUserId(userId);
//    msg.setMessageTypeEnum(MessageTypeEnum.PHONE_MESSAGE);
//    userService.sendRestPasswordMsg(getCurrentUser().getCurrentTenantId(),msg);
//  }
//
//
//  @PostMapping("/sendRestPasswordMsg")
//  public void resetPassword(@RequestBody SendResetPasswordEmailMsg msg) throws ThingsboardException {
//    userService.sendRestPasswordMsg(getCurrentUser().getCurrentTenantId(),msg);
//  }
//}
