package com.tofly.base.ding;

import com.tofly.base.ding.base.entity.DingDeptVo;
import com.tofly.base.ding.handle.DingDeptHandle;
import com.tofly.base.service.organization.TkOrganizationService;
import com.tofly.base.service.user.TkUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class DingTask {
    @Autowired
    private  TkOrganizationService organizationService;
    @Autowired
    private  TkUserService tkUserService;
    @Scheduled(cron = "5 0 * * * *") // 每天凌晨0点5分执行
    public  void  pullDingInfo(){
        final List<DingDeptVo> dingDeptVos = DingDeptHandle.pullDingDept();

        organizationService.saveOrUpdateOrganizationByDingDept(dingDeptVos);

        for (DingDeptVo dingDeptVo : dingDeptVos) {
            tkUserService.pullUserFromDing(dingDeptVo.getDeptId());
        }

    }
}
