package com.tofly.base.ding.handle;

import com.alibaba.fastjson.JSON;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.OapiV2DepartmentListsubRequest;
import com.dingtalk.api.response.OapiV2DepartmentListsubResponse;
import com.taobao.api.ApiException;
import com.tofly.base.ding.base.entity.DingDeptVo;
import com.tofly.base.ding.base.vo.DingDeptResponseVo;

import java.util.ArrayList;
import java.util.List;

public class DingDeptHandle {

    public  static  List<DingDeptVo> pullDingDept(){
        try {
            List<DingDeptVo> list = new ArrayList<>();
            pullDeptById(list,1l, DingLoginHandle.getLoinToken());

          return  list;

        } catch (Exception e) {
            e.printStackTrace();
        }
        return  null;
    }

    private static void pullDeptById(List<DingDeptVo> list,Long id,String accessToken){
        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/department/listsub");

        OapiV2DepartmentListsubRequest req = new OapiV2DepartmentListsubRequest();
        if(id==null){
            req.setDeptId(1l);
        }else{
            req.setDeptId(id);
        }

        try {
            OapiV2DepartmentListsubResponse rsp = client.execute(req, accessToken);
            final DingDeptResponseVo dingDeptResponseVo
                    = JSON.parseObject(rsp.getBody(), DingDeptResponseVo.class);
            if(dingDeptResponseVo.getResult().size()>0){
                list.addAll(dingDeptResponseVo.getResult());
                for (DingDeptVo dingDeptVo : dingDeptResponseVo.getResult()) {

                    pullDeptById(list,dingDeptVo.getDeptId(),accessToken);
                }
            }
        } catch (ApiException e) {
            e.printStackTrace();
        }


    }
//
//    public static void main(String[] args) {
//
//        pullDingDept();
//    }

}
