package com.tofly.base.entity.enterprise;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.tofly.base.server.common.data.TenantBaseEntity;
import com.tofly.base.server.common.data.constant.ModelConstants;
import lombok.Data;
import lombok.RequiredArgsConstructor;

/**
 * @author: 徐浩然
 * @desc: 企业信息
 * @date: 2021/12/3-18:11
 */
@Data
@RequiredArgsConstructor
@TableName(ModelConstants.Table.SYS_ENTERPRISE_TABLE_NAME)
public class SysEnterpriseEntity extends TenantBaseEntity {
  private static final long serialVersionUID = -804373668052255756L;
  /** 公司名称 */
  private String name;
  /** 公司简称 */
  private String abbreviation;
  /** 公司官网 */
  private String officialWebsite;
  /** 公司邮箱 */
  private String email;
  /** 公司简介 */
  private String synopsis;
  /** 详细地址 */
  private String address;
  /** 联系人 */
  private String contacts;
  /** 区号 */
  private String area;
  /** 联系电话 */
  private String tel;
  /** 县code */
  @TableField(updateStrategy = FieldStrategy.IGNORED)
  private Long codeTown;
  /** 二维码 */
  private String qrCode;
}
