/**
 * Copyright © 2016-2022 The Thingsboard Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.tofly.base.entity.log;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.fasterxml.jackson.databind.JsonNode;
import com.tofly.base.entity.BaseEntity;
import com.tofly.base.server.common.data.EntityType;
import com.tofly.base.server.common.data.enums.ActionStatus;
import com.tofly.base.server.common.data.enums.ActionType;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.UUID;

@Data
@EqualsAndHashCode(callSuper = true)
@TableName(com.tofly.base.server.common.data.constant.ModelConstants.Table.AUDIT_LOG_COLUMN_FAMILY_NAME)
public class SysLogEntity extends BaseEntity {


    private UUID tenantId;

    private long createdTime;
    private UUID customerId;

    private EntityType entityType;


    private UUID entityId;


    private String entityName;


    private UUID userId;

    private String userName;


    private ActionType actionType;

    @TableField(typeHandler = JacksonTypeHandler.class)
    private JsonNode actionData;

    private ActionStatus actionStatus;


    private String actionFailureDetails;


}
