package com.tofly.base.entity.menu;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * @author Mu
 * @date 2023-07-12
 * @description (FormVisibleConfig实体类)
 */
@Data
@TableName("form_visible_config")
@ApiModel(value = "", description = "对象 formVisibleConfig")
public class FormVisibleConfig {

    /**
     * 主键
     */
    @TableId(type = IdType.ASSIGN_ID)
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    @JsonSerialize(using = ToStringSerializer.class)
    @ExcelIgnore
    private Long id;
    /**
     * 业务编码
     */
    private String menuId;
    /**
     * 字段
     */
    private String propField;
    /**
     * 字段
     */
    private String propName;
    /**
     * 业务类型 0 列表   1 详情
     */
    private String type;
    /**
     * 是否显示
     */
    private String isshow;
}
