package com.tofly.base.entity.menu;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.fasterxml.jackson.databind.JsonNode;
import com.tofly.base.server.common.data.TenantBaseEntity;
import com.tofly.base.server.common.data.constant.ModelConstants;
import com.tofly.base.server.common.data.enums.MenuTypeEnum;
import lombok.Data;
import lombok.EqualsAndHashCode;

@Data
@EqualsAndHashCode(callSuper = true)
@TableName(ModelConstants.Table.SYS_MENU_TABLE_NAME)
public class SysMenuEntity extends TenantBaseEntity {

  private static final long serialVersionUID = 6319718763792214142L;
  private String name;

  private String parentId;

  private String path;

  private MenuTypeEnum type;

  private String permission;

  private Integer sort;

  @TableField(typeHandler = JacksonTypeHandler.class)
  private JsonNode meta;

  private String alias;

  private String redirect;

  private Boolean caseSensitive;

  private String component;
  
  private String menuSys;

  private String menuOut;

  private Integer isshowimg;

  private String imgbase64;
  
}
