package com.tofly.base.entity.user;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.tofly.base.server.common.data.TenantBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

/** user是所有可登录系统用户 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName(com.tofly.base.server.common.data.constant.ModelConstants.Table.SYS_USER_TABLE_NAME)
public class SysUserEntity extends TenantBaseEntity {
  private static final long serialVersionUID = 834982016421849497L;
  private String username;

  private String realName;

  private String password;

  @TableField(updateStrategy = FieldStrategy.IGNORED)
  private String activateToken;

  private String phoneNumber;

  @TableField(updateStrategy = FieldStrategy.IGNORED)
  private String email;

  private String avatar;

  private boolean enabled = true;

  @TableField(updateStrategy = FieldStrategy.IGNORED)
  private Date accountExpireTime;

  private String deptId;

  /** TB的UserId */
  private String tbUser;

  /** 0：超级管理员；1：租户账号；2：租户下的账号 */
  private Integer level;

  private String  remark;
  
  private Integer isFirst;

  private String dingId;
  /**
   *  1在职  2离职
   */
  private String status;

  /**
   * 是否为管理员  1 是 0否
   */
  private String isAdmin;
}
