package com.tofly.base.entity.user;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.fasterxml.jackson.databind.JsonNode;
import com.tofly.base.server.common.data.TenantBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = com.tofly.base.server.common.data.constant.ModelConstants.Table.TK_MESSAGE_CONFIG_TABLE_NAME, autoResultMap = true)
public class TkMessageConfigEntity extends TenantBaseEntity {

  private static final long serialVersionUID = -3624943194108704138L;

  /** 配置名称 */
  private String configName;

  /** 平台类型 */
  private String platformType;

  /** 消息类型 */
  private String messageType;

  /** json配置 */
  @TableField(typeHandler = JacksonTypeHandler.class)
  private JsonNode config;

  /** 状态：0禁用 1启用 */
  private Integer status;

  /** 备注 */
  private String remark;
}
