package com.tofly.base.entity.user;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.fasterxml.jackson.databind.JsonNode;
import com.tofly.base.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

@Data
@EqualsAndHashCode(callSuper = false)
@TableName(value = com.tofly.base.server.common.data.constant.ModelConstants.Table.TK_SMS_LOG_TABLE_NAME,autoResultMap = true)
public class TkSmsLogEntity extends BaseEntity {

  private static final long serialVersionUID = 2778820322396894328L;

  /** 短信平台类型 */
  private String type;

  /** 发送状态：ResponseCodeEnum枚举值 */
  private String status;

  /** 发送时间 */
  @TableField(fill = FieldFill.INSERT)
  private LocalDateTime sendTime;

  /** 发送手机号 */
  private String toPhone;

  /** 发送模板参数 */
  @TableField(typeHandler = JacksonTypeHandler.class)
  private JsonNode templateParam;

  /** 租户Code */
  private String tenantId;

  /** 模板ID */
  private String messageTemplateId;

  /**用途*/
  private String templatePurpose;

  /**备注*/
  private String remark;
}
