package com.tofly.base.mapper;

/**
 * @version V1.0
 * @Description :
 * 1.其它地方抛出异常，交由控制层统一处理
 * 2.服务层注意持久化的事务管理
 * @Dependency: 依赖包
 * @Author: junlianglee
 * @Date Created in 2021/12/28$
 * @Copyright 2016-2018  - Powered By 同飞科技
 */

import org.apache.ibatis.type.BaseTypeHandler;
import org.apache.ibatis.type.JdbcType;

import java.sql.CallableStatement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.UUID;

public class UUIDTypeHandler extends BaseTypeHandler {

    @Override
    public Object getNullableResult(ResultSet rs, String columnName)
            throws SQLException {
        return UUID.fromString(rs.getString(columnName));
    }

    @Override
    public Object getNullableResult(ResultSet resultSet, int i) throws SQLException {
        return UUID.fromString((resultSet.getString(i)));
    }

    @Override
    public Object getNullableResult(CallableStatement cs, int columnIndex)
            throws SQLException {
        return UUID.fromString((cs.getString(columnIndex)));
    }

    @Override
    public void setNonNullParameter(PreparedStatement ps, int i,
                                    Object parameter, JdbcType jdbcType) throws SQLException {
        ps.setString(i, ((UUID) parameter).toString());
    }
}
