package com.tofly.base.mapper.dic;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.tofly.base.entity.dic.SysDictItemEntity;
import com.tofly.base.server.common.data.dto.SysDictItemDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Set;

@Mapper
public interface SysDictItemMapper extends BaseMapper<SysDictItemEntity> {
  /**
   * 通过dict表的Code和dictItem的codeText查询字典表的值
   *
   * @param dictCode 字典表Code
   * @param itemValue 字典Item表文本值
   * @return 返回字典Item表文本对应的文本
   */
  SysDictItemDTO getDictValueByCodeAndText(
      @Param("dictCode") String dictCode,
      @Param("itemValue") String itemValue);
  /**
   * 根据租户Code和字典表ID查询字典值
   *
   * @param dictId 字典表ID
   * @return List<SysDictItemDTO>
   */
  List<SysDictItemDTO> getDictItemInfo(
      @Param("dictId") String dictId,
      @Param("dictCode") String dictCode);



  List<String> getItemCodes( @Param("sysDictItemIds") Set<String> sysDictItemIds);
}
