package com.tofly.base.mapper.dic;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.tofly.base.entity.dic.SysDictEntity;
import com.tofly.base.server.common.data.dto.SysDictDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface SysDictMapper extends BaseMapper<SysDictEntity> {

  /**
   * 根据租户Code和字典编码获取字典信息
   *
   * @param tenantId 租户Code
   * @param dictCode 字典信息
   * @return SysDictDTO字典信息
   */
  SysDictDTO getDictInfoByCode(
      @Param("tenantId") String tenantId,
      @Param("dictCode") String dictCode);
}
