package com.tofly.base.mapper.menu;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.tofly.base.entity.menu.SysMenuEntity;
import com.tofly.base.server.common.data.dto.MenuDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Set;

@Mapper
public interface MenuMapper extends BaseMapper<SysMenuEntity> {
  List<MenuDTO> selectTenantMenu(String tenantId);

  List<MenuDTO> selectSysAdminMenu();

  List<MenuDTO> selectMyMenu(String userId);

  int deleteTenantMenuMappingByMenuIds(@Param("menuIds") Collection<String> menuIds);

  Set<String> selectTenantMenuIds(String tenantId);

  Set<String> selectRoleMenuIds(String roleId);

  Set<String> getAllIdsByTenantId(@Param("tenantIds") Collection<String> tenantIds);

  int addMenuToTenant(
          @Param("tenantId") String tenantId, @Param("menuIds") Collection<String> menuIds);

  int addMenuToRole(
          @Param("roleId") String roleId, @Param("menuIds") Collection<String> menuIds);

  int removeMenuFromTenant(
          @Param("tenantId") String tenantId, @Param("menuIds") Collection<String> menuIds);

  int removeMenuFromRole(
          @Param("roleId") String roleId, @Param("menuIds") Collection<String> menuIds);

  Set<String> getAllPermission();

  Set<String> getAllPermissionsByTenantId(String tenantId);

  Set<String> getAllPermissionsByUserId(String userId);
}
