package com.tofly.base.mapper.organization;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.tofly.base.entity.organization.TkOrganizationEntity;
import com.tofly.base.server.common.data.dto.OrganizationDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

@Mapper
public interface OrganizationMapper extends BaseMapper<TkOrganizationEntity> {
  /**
   * 通过租户code和组织Id递归查询其组织及子组织的List
   *
   * @param tenantId 租户code
   * @param organizationIds 待查询的组织ID,可以为空
   * @return 组织及子组织，直到叶节点
   */
  List<OrganizationDTO> findOrganizationTreeList(
      @Param("tenantId") String tenantId, @Param("organizationIds") Collection<String> organizationIds);


  List<OrganizationDTO> deletefindOrganizationTreeList(
          @Param("tenantId") String tenantId, @Param("organizationIds") Collection<String> organizationIds);
}
