package com.tofly.base.mapper.role;


import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.tofly.base.entity.role.SysRoleEntity;
import com.tofly.base.server.common.data.dto.RoleDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Set;

@Mapper
public interface RoleMapper extends BaseMapper<SysRoleEntity> {
  void deleteRoleBatchByTenantIds(@Param("tenantIds") Collection<String> tenantIds);

  int deleteRoleMenuMappingByRoleIds(@Param("roleIds") Collection<String> roleIds);

  int deleteRoleMenuMappingByMenuIds(@Param("menuIds") Collection<String> menuIds);

  int deleteRoleUserMappingByRoleIds(@Param("roleIds") Collection<String> roleIds);

  int deleteRoleUserMappingByUserIds(@Param("userIds") Collection<String> userIds);

  Set<String> getAllIdsByTenantId(@Param("tenantIds") Collection<String> tenantIds);

  Set<String> checkRoleUserMappingByRoleIds(@Param("ids") Collection<String> ids);

  Set<SysRoleEntity> selectRoleByUserId(String userId);

  Set<String> getMenuIdsByRoleId(String roleId);

  void saveUserRoleMapping(@Param("userId")String userId,@Param("roleId")String roleId);

  List<RoleDTO> findRoleInfo(RoleDTO roleDTO);

    Boolean getHasRoleByUserId(@Param("userID")String userID, @Param("roleName")String roleName);
}
