package com.tofly.base.mapper.user;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.tofly.base.entity.user.TkMessageTemplateEntity;
import com.tofly.base.server.common.data.dto.MessageTemplateDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

@Mapper
public interface MessageTemplateMapper extends BaseMapper<TkMessageTemplateEntity> {
  /**
   * 获取模板分页数据
   *
   * @param page 分页数据
   * @param queryMap 查询参数
   * @return
   */
  IPage<MessageTemplateDTO> getTemplatePage(
      IPage<?> page, @Param("queryMap") Map<String, Object> queryMap);

  /**
   * 查询模板信息
   * @param templateDTO 请求参数
   * @return 模板信息列表 List<MessageTemplateDTO>
   */
  List<MessageTemplateDTO> findMessageTemplate(MessageTemplateDTO templateDTO);
}
