package com.tofly.base.mapper.user;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.tofly.base.entity.user.SysUserEntity;
import com.tofly.base.server.common.data.dto.UserDTO;
import com.tofly.base.server.common.data.dto.UserDetailsDTO;
import com.tofly.base.server.common.data.enums.RoleEnum;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;

@Mapper
public interface UserMapper extends BaseMapper<SysUserEntity> {

  List<UserDetailsDTO> findUserDetailsByUserName(
      @Param("username") String username, @Param("tenantId") String tenantId);

  List<UserDetailsDTO> findUserDetailsByPhoneNumber(String phoneNumber);

  IPage<UserDTO> getUserPage(IPage<?> page, @Param("queryMap") Map<String, Object> queryMap);

  IPage<UserDTO> getTenantAdminPage(IPage<?> page, @Param("tenantId") String tenantId);

  Set<String> getAllIdsByTenantId(@Param("tenantIds") Collection<String> tenantIds);

  UserDTO findUserInfo(UserDTO userDTO);

  List<UserDTO> findUserInfoByPhoneNumber(UserDTO userDTO);

  String findUserCustomerIdById(@Param("userId") String userId);

  List<UserDTO> getUserCountByRoleType(@Param("roleType") RoleEnum roleType);

  List<UserDTO> getMyCustomers(
      @Param("tenantId") String tenantId,
      @Param("customerId") String customerId,
      @Param("userIds") Collection<String> userIds);

  List<UserDTO> findUsersAsyncByTs(@Param("startTs") String startTs, @Param("endTs") String endTs);

  String findCustomerIdByUserId(@Param("id") String id);

  List<UserDetailsDTO> findCustomers(@Param("queryMap") Map<String, Object> queryMap);
  
  
  List<Map<String,String>> getAddressBook();
  
  
  
}
