package com.tofly.base.server.common.data.constant;

import java.util.regex.Pattern;

public interface FastIotConstants {
  Integer JAVA_SCRIPT = 0;
  Integer CONVERT_DATA = 1;
  Integer SCENE_REACT = 2;
  Integer MOBILE_TYPE = 0;
  Integer PC_TYPE = 1;
  String FIRST_PAGE_NAME = "第 1 页";
  String CHART_EXECUTE_CONDITION = "executeCondition";
  String CHART_EXECUTE_ATTRIBUTES = "executeAttributes";
  String ASSERT_DEFAULT_NAME = "default";
  public static final String TCP_DEVICE_IDENTIFY_FILED = "deviceCode";
  String MOBILE =
      "^[1](([3][0-9])|([4][0,1,4-9])|([5][0-3,5-9])|([6][2,5,6,7])|([7][0-8])|([8][0-9])|([9][0-3,5-9]))[0-9]{8}$";
  String EMAIL = "^[A-Z0-9._%+-]+@[A-Z0-9.-]+\\.[A-Z]{2,}$";
  Pattern EMAIL_PATTERN = Pattern.compile(EMAIL, Pattern.CASE_INSENSITIVE);
  Pattern CHINA_MOBILE_PATTERN = Pattern.compile(MOBILE);
  String DEFAULT_DELIMITER = "#";
  interface CacheConfigKey {
    String CACHE_CONFIG_KEY = "toflyIotCache";
    String USER_PERMISSION_PREFIX = "userPermissionFor_";
    String MOBILE_LOGIN_SMS_CODE = "mobileLoginSmsCode";

    String AREA = "thingsArea";
  }
  interface TBCacheConfig {
    String TB_CACHE_CONFIG_KEY = "TB_CONNECT_CACHE";
    String EXISTING_TENANT = "EXISTING_TENANT";
  }

  interface ReadState {
    String UNREAD = "0";
    String READ = "1";
  }

  interface ReceiverType {
    int PERSONAL = 3;
    int DEPARTMENT = 2;
    int ORGANIZATION = 1;
    int ALL = 0;
  }

  interface DraftStatus {
    int PUBLISHED = 1;
    int DRAFT = 0;
  }


  interface ConfigureLevel {
    String CONFIGURE = "CONFIGURE";
    String CONTENT = "CONTENT";
    String NODE = "NODE";
  }

  class DefaultOrder {
    public static final String CREATE_TIME = "create_time";
  }

  class ScheduleConstants {
    public static final String TASK_CLASS_NAME = "TASK_CLASS_NAME";

    /** 执行目标key */
    public static final String TASK_PROPERTIES = "TASK_PROPERTIES";

    /** 默认 */
    public static final int MISFIRE_DEFAULT = 0;

    /** 立即触发执行 */
    public static final int MISFIRE_IGNORE_MISFIRES = 1;

    /** 触发一次执行 */
    public static final int MISFIRE_FIRE_AND_PROCEED = 2;

    /** 不触发立即执行 */
    public static final int MISFIRE_DO_NOTHING = 3;

    /** 定时任务白名单配置（仅允许访问的包名，如其他需要可以自行添加） */
    public static final String[] JOB_WHITELIST_STR = {
      "com.tofly.yxBase.server.dao.util.task"
    };
    /** http请求 */
    public static final String HTTP = "http://";

    /** https请求 */
    public static final String HTTPS = "https://";

    /** RMI 远程方法调用 */
    public static final String LOOKUP_RMI = "rmi:";

    /** LDAP 远程方法调用 */
    public static final String LOOKUP_LDAP = "ldap:";

    /** LDAPS 远程方法调用 */
    public static final String LOOKUP_LDAPS = "ldaps:";
    /** 定时任务违规的字符 */
    public static final String[] JOB_ERROR_STR = {
      "java.net.URL",
      "javax.naming.InitialContext",
      "org.yaml.snakeyaml",
      "org.springframework",
      "org.apache"
    };
  }

  class MagicNumber {
    public static final int ZERO = 0;
    public static final int ONE = 1;
    public static final int TEN = 10;
  }

  class ConfigJSONKey {
    public static final String BASE_URL = "baseUrl";
  }

  class Relation {
    public static final String relationType = "Created";
  }

  class StateValue {
    /** 禁用 */
    public static final int DISABLE = 0;
    /** 启用 */
    public static final int ENABLE = 1;

    /** 离线 */
    public static final int OFFLINE = 0;
    /** 在线 */
    public static final int ONLINE = 1;

    /** 删除成功 */
    public static final String DELETE_SUCCESS = "删除成功";

    /** 删除失败 */
    public static final String DELETE_FAILED = "删除失败";
  }

  class LevelValue {
    /** 超级管理员 */
    public static final int IS_ADMIN = 0;

    /** 系统平台其他管理员 */
    public static final int IS_PLATFORM_ADMIN = 1;

    /** 租户管理员 */
    public static final int IS_TENANT_ADMIN = 2;

    /** 租户下的用户 */
    public static final int IS_CUSTOMER_USER = 3;
  }
}
