package com.tofly.base.server.common.data.constant;

import com.datastax.oss.driver.api.core.uuid.Uuids;
import com.tofly.base.server.common.data.id.TenantId;
import com.tofly.base.server.utils.SetUtil;

import java.util.Set;
import java.util.UUID;


public final class ModelConstants {
  public static class Table {
	  
	public static final String AUDIT_LOG_COLUMN_FAMILY_NAME = "audit_log"; 
	  
    /** 系统用户表 */
    public static final String SYS_USER_TABLE_NAME = "sys_user";
    /** 租户表 */
    public static final String SYS_TENANT_TABLE_NAME = "sys_tenant";
    /** 租户菜单表 */
    public static final String SYS_TENANT_MENU_TABLE_NAME = "sys_tenant_menu";
    /** 租户角色表 */
    public static final String SYS_TENANT_ROLE_TABLE_NAME = "sys_tenant_role";
    /** 菜单表 */
    public static final String SYS_MENU_TABLE_NAME = "sys_menu";
    /** 通知管理 */
    public static final String SYS_NOTICE_TABLE_NAME = "sys_notice";
    /** 我的通知 */
    public static final String SYS_NOTICE_USER_TABLE_NAME = "sys_notice_user";
    /** 角色表 */
    public static final String SYS_ROLE_TABLE_NAME = "sys_role";
    /** 用户角色关系表 */
    public static final String SYS_USER_ROLE_TABLE_NAME = "sys_user_role";
    
    
    /** 角色数据权限关系表 */
    public static final String SYS_ROLE_DATA_PERMISSION_TABLE_NAME = "sys_role_data_permission";
    
    
    /** 系统用户设置表 */
    public static final String SYS_ADMIN_SETTING_TABLE_NAME = "sys_admin_setting";
    /** 字典表 */
    public static final String SYS_DICT_TABLE_NAME = "sys_dict";
    /** 字典值表 */
    public static final String SYS_DICT_ITEM_TABLE_NAME = "sys_dict_item";
    /** 消息字典表 */
    public static final String TK_MESSAGE_CONFIG_TABLE_NAME = "tk_message_config";
    /** 消息模板表 */
    public static final String TK_MESSAGE_TEMPLATE_TABLE_NAME = "tk_message_template";
    /** 短信发送记录表 */
    public static final String TK_SMS_LOG_TABLE_NAME = "tk_sms_log";
    /** 邮件发送记录表 */
    public static final String TK_MAIL_LOG_TABLE_NAME = "tk_mail_log";
    /** 限流表 */
    public static final String SYS_RATE_LIMIT_TABLE_NAME = "sys_rate_limit";
    /** 系统部门表 */
    public static final String SYS_DEPT_TABLE_NAME = "sys_dept";
    /** 系统定时任务表 */
    public static final String SYS_JOB_TABLE_NAME = "sys_job";
    /** 定时任务执行记录表 */
    public static final String SYS_JOB_LOG_TABLE_NAME = "sys_job_log";
    /** 组织表 */
    public static final String TK_ORGANIZATION_TABLE_NAME = "tk_organization";
    /** 用户与组织映射表 */
    public static final String TK_USER_ORGANIZATION_MAPPING_TABLE_NAME =
        "tk_user_organization_mapping";
    /** 设备表 */
    public static final String TK_DEVICE_TABLE_NAME = "tk_device";
    /** 产品信息(设备配置)扩展表 */
    public static final String TK_DEVICE_PROFILE_TABLE_NAME = "tk_device_profile";
    /** 自定义数据协议解析脚本 */
    public static final String TK_DEVICE_SCRIPT_TABLE_NAME = "tk_java_script";

    /** 设备类型表 */
    public static final String TK_DEVICE_TYPE_TABLE_NAME = "tk_device_type";
    /** 告警配置表 */
    public static final String TK_ALARM_PROFILE_TABLE_NAME = "tk_alarm_profile";
    /** 告警联系人 */
    public static final String TK_ALARM_CONTACT_TABLE_NAME = "tk_alarm_contact";
    /** 企业信息 */
    public static final String SYS_ENTERPRISE_TABLE_NAME = "sys_enterprise";
    /** 平台定制 */
    public static final String SYS_PLATFORM_DESIGN_TABLE_NAME = "sys_platform_design";
    /** APP定制 */
    public static final String SYS_APP_DESIGN_TABLE_NAME = "sys_app_design";
    /** 场景联动表 */
    public static final String TK_SCENE_LINKAGE_TABLE_NAME = "tk_scene_linkage";
    /** 场景触发器 */
    public static final String TK_TRIGGER_TABLE_NAME = "tk_trigger";
    /** 执行条件表 */
    public static final String TK_DO_CONDITION_TABLE_NAME = "tk_do_condition";
    /** 条件动作表 */
    public static final String TK_DO_ACTION_TABLE_NAME = "tk_do_action";
    /** 中国城镇区街 */
    public static final String SYS_AREA_TABLE_NAME = "sys_area";
    /** 数据流转配置表 */
    public static final String TK_CONVERT_CONFIG_TABLE_NAME = "tk_convert_config";
    /** 组态中心 */
    public static final String TK_CONFIGURATION_CENTER_NAME = "tk_configuration_center";
    /** 组态内容 */
    public static final String TK_CONFIGURATION_CONTENT_NAME = "tk_configuration_content";
    /** 组态节点数据源 */
    public static final String TK_CONFIGURATION_DATASOURCE = "tk_configuration_datasource";
    /** 组态节点数据交互 */
    public static final String TK_CONFIGURATION_EVENT = "tk_configuration_event";
    /** 组态节点动画效果 */
    public static final String TK_CONFIGURATION_ACT = "tk_configuration_act";
    /** 视频流 */
    public static final String TK_VIDEO_STREAM_TABLE_NAME = "tk_device_camera";
    /** 流媒体配置 */
    public static final String TK_VIDEO_PLATFORM_TABLE_NAME = "tk_video_platform";
    /** 意见反馈 */
    public static final String TK_OPINION_TABLE_NAME = "tk_opinion";
    /** 第三方用户表 */
    public static final String TK_THIRD_USER_TABLE_NAME = "tk_third_user";
    /** frp内网穿透信息表 */
    public static final String TK_FRP_INFO_NAME = "tk_frp_info";
    /** 报表配置表 */
    public static final String TK_REPORT_FORM_CONFIG_NAME = "tk_report_form_config";
    /** 报表生成记录表 */
    public static final String TK_REPORT_GENERATE_RECORD_NAME = "tk_report_generate_record";
    /** 数据看板 */
    public static final String TK_DATA_BOARD_NAME = "tk_data_board";
    /** 数据组件 */
    public static final String TK_DATA_COMPONENT_NAME = "tk_data_component";
    /** 物模型 */
    public static final String TK_THING_MODEL = "tk_things_model";
    /** 客户和设备的映射表 */
    public static final String TK_CUSTOMER_DEVICE_NAME = "tk_customer_device";
    /** 设备上下线记录表 */
    public static final String TK_DEVICE_STATE_LOG = "tk_device_state_log";
    /** 属性组*/
    public static final String TK_PROP_GROUP = "tk_prop_group";
    /** 设备发现*/
    public static final String TK_DEVICE_DISCOVERY = "tk_device_discovery";
  }

  public static class TableFields {
    public static final String TENANT_ID = "tenant_id";
  }

  public static class TablePropertyMapping {
    public static final String ID = "id";
    public static final String CREATE_TIME = "createTime";
    public static final String CREATE_DATE= "createDate";
    public static final String UPDATE_TIME = "updateTime";
    public static final String CREATOR = "creator";
    public static final String CREATE_USER = "createUser";
    public static final String UPDATER = "updater";
    public static final String DELETED = "deleted";
    public static final String  UPDATEUSER = "updateUser";
    public static final String UPDATE = "update";
    public static final String TENANT_CODE = "tenantId";
    public static final String PASSWORD = "password";
    public static final String ACTIVATE_TOKEN = "activateToken";
    public static final String TB_DEVICE_ID = "tbDeviceId";
    public static final String DEVICE_STATE = "deviceState";
    public static final String ACTIVE_TIME = "activeTime";
    public static final String COMMAND_TYPE = "cmdType";
    public static final String ADDITIONALINFO_DESCRIPTION = "description";

    public static final Set<String> COMMON_PROPS = SetUtil.toSet("device_id", "tofly_device_id", "collect_time", "generation_time");
  }

  public static class AdminSettingConfigKey {
    public static final String GENERAL_SETTING = "general";
  }
  
  
  
  public static final UUID NULL_UUID = Uuids.startOf(0);
  public static final TenantId SYSTEM_TENANT = TenantId.fromUUID(ModelConstants.NULL_UUID);

  // this is the difference between midnight October 15, 1582 UTC and midnight January 1, 1970 UTC as 100 nanosecond units
  public static final long EPOCH_DIFF = 122192928000000000L;

  /**
   * Generic constants.
   */
  public static final String ID_PROPERTY = "id";
  public static final String CREATED_TIME_PROPERTY = "created_time";
  public static final String STATUS_PROPERTY = "status";
  public static final String USER_ID_PROPERTY = "user_id";
  public static final String TENANT_ID_PROPERTY = "tenant_id";
  public static final String CUSTOMER_ID_PROPERTY = "customer_id";
  public static final String DEVICE_ID_PROPERTY = "device_id";
  public static final String TITLE_PROPERTY = "title";
  public static final String ALIAS_PROPERTY = "alias";
  public static final String SEARCH_TEXT_PROPERTY = "search_text";
  public static final String ADDITIONAL_INFO_PROPERTY = "additional_info";
  public static final String ENTITY_TYPE_PROPERTY = "entity_type";

  public static final String ENTITY_TYPE_COLUMN = ENTITY_TYPE_PROPERTY;
  public static final String TENANT_ID_COLUMN = "tenant_id";
  public static final String ENTITY_ID_COLUMN = "entity_id";
  public static final String ATTRIBUTE_TYPE_COLUMN = "attribute_type";
  public static final String ATTRIBUTE_KEY_COLUMN = "attribute_key";
  public static final String LAST_UPDATE_TS_COLUMN = "last_update_ts";

  //Thingskit function
  public static final String EVENT_IDENTIFIER_COLUMN = "event_identifier";
  public static final String EVENT_TIME_COLUMN = "event_time";
  public static final String EVENT_TYPE_COLUMN = "event_type";
  public static final String EVENT_VALUE_COLUMN = "event_value";

  /**
   * Cassandra user constants.
   */
  public static final String USER_COLUMN_FAMILY_NAME = "user";
  public static final String USER_PG_HIBERNATE_COLUMN_FAMILY_NAME = "tb_user";
  public static final String USER_TENANT_ID_PROPERTY = TENANT_ID_PROPERTY;
  public static final String USER_CUSTOMER_ID_PROPERTY = CUSTOMER_ID_PROPERTY;
  public static final String USER_EMAIL_PROPERTY = "email";
  public static final String USER_AUTHORITY_PROPERTY = "authority";
  public static final String USER_FIRST_NAME_PROPERTY = "first_name";
  public static final String USER_LAST_NAME_PROPERTY = "last_name";
  public static final String USER_ADDITIONAL_INFO_PROPERTY = ADDITIONAL_INFO_PROPERTY;

  public static final String USER_BY_EMAIL_COLUMN_FAMILY_NAME = "user_by_email";
  public static final String USER_BY_TENANT_AND_SEARCH_TEXT_COLUMN_FAMILY_NAME = "user_by_tenant_and_search_text";
  public static final String USER_BY_CUSTOMER_AND_SEARCH_TEXT_COLUMN_FAMILY_NAME = "user_by_customer_and_search_text";

  /**
   * Cassandra user_credentials constants.
   */
  public static final String USER_CREDENTIALS_COLUMN_FAMILY_NAME = "user_credentials";
  public static final String USER_CREDENTIALS_USER_ID_PROPERTY = USER_ID_PROPERTY;
  public static final String USER_CREDENTIALS_ENABLED_PROPERTY = "enabled";
  public static final String USER_CREDENTIALS_PASSWORD_PROPERTY = "password"; //NOSONAR, the constant used to identify password column name (not password value itself)
  public static final String USER_CREDENTIALS_ACTIVATE_TOKEN_PROPERTY = "activate_token";
  public static final String USER_CREDENTIALS_RESET_TOKEN_PROPERTY = "reset_token";

  public static final String USER_CREDENTIALS_BY_USER_COLUMN_FAMILY_NAME = "user_credentials_by_user";
  public static final String USER_CREDENTIALS_BY_ACTIVATE_TOKEN_COLUMN_FAMILY_NAME = "user_credentials_by_activate_token";
  public static final String USER_CREDENTIALS_BY_RESET_TOKEN_COLUMN_FAMILY_NAME = "user_credentials_by_reset_token";

  /**
   * Cassandra admin_settings constants.
   */
  public static final String ADMIN_SETTINGS_COLUMN_FAMILY_NAME = "admin_settings";
  public static final String ADMIN_SETTINGS_KEY_PROPERTY = "key";
  public static final String ADMIN_SETTINGS_JSON_VALUE_PROPERTY = "json_value";

  public static final String ADMIN_SETTINGS_BY_KEY_COLUMN_FAMILY_NAME = "admin_settings_by_key";

  /**
   * Cassandra contact constants.
   */
  public static final String COUNTRY_PROPERTY = "country";
  public static final String STATE_PROPERTY = "state";
  public static final String CITY_PROPERTY = "city";
  public static final String ADDRESS_PROPERTY = "address";
  public static final String ADDRESS2_PROPERTY = "address2";
  public static final String ZIP_PROPERTY = "zip";
  public static final String PHONE_PROPERTY = "phone";
  public static final String EMAIL_PROPERTY = "email";

  /**
   * Cassandra tenant constants.
   */
  public static final String TENANT_COLUMN_FAMILY_NAME = "tenant";
  public static final String TENANT_TITLE_PROPERTY = TITLE_PROPERTY;
  public static final String TENANT_REGION_PROPERTY = "region";
  public static final String TENANT_ADDITIONAL_INFO_PROPERTY = ADDITIONAL_INFO_PROPERTY;
  public static final String TENANT_TENANT_PROFILE_ID_PROPERTY = "tenant_profile_id";

  public static final String TENANT_BY_REGION_AND_SEARCH_TEXT_COLUMN_FAMILY_NAME = "tenant_by_region_and_search_text";

  /**
   * Tenant profile constants.
   */
  public static final String TENANT_PROFILE_COLUMN_FAMILY_NAME = "tenant_profile";
  public static final String TENANT_PROFILE_NAME_PROPERTY = "name";
  public static final String TENANT_PROFILE_PROFILE_DATA_PROPERTY = "profile_data";
  public static final String TENANT_PROFILE_DESCRIPTION_PROPERTY = "description";
  public static final String TENANT_PROFILE_IS_DEFAULT_PROPERTY = "is_default";
  public static final String TENANT_PROFILE_ISOLATED_TB_CORE = "isolated_tb_core";
  public static final String TENANT_PROFILE_ISOLATED_TB_RULE_ENGINE = "isolated_tb_rule_engine";

  /**
   * Cassandra customer constants.
   */
  public static final String CUSTOMER_COLUMN_FAMILY_NAME = "customer";
  public static final String CUSTOMER_TENANT_ID_PROPERTY = TENANT_ID_PROPERTY;
  public static final String CUSTOMER_TITLE_PROPERTY = TITLE_PROPERTY;
  public static final String CUSTOMER_ADDITIONAL_INFO_PROPERTY = ADDITIONAL_INFO_PROPERTY;

  public static final String CUSTOMER_BY_TENANT_AND_SEARCH_TEXT_COLUMN_FAMILY_NAME = "customer_by_tenant_and_search_text";
  public static final String CUSTOMER_BY_TENANT_AND_TITLE_VIEW_NAME = "customer_by_tenant_and_title";
  
  
  
  
}
