package com.tofly.base.server.common.data.core.exception;

import com.tofly.base.server.common.data.core.message.ErrorMessage;
import lombok.Getter;
import org.springframework.http.HttpStatus;

public class ToflylinksException extends RuntimeException {
  private static final long serialVersionUID = 4036257507478854844L;

  @Getter private final HttpStatus httpStatus;

  @Getter private final ErrorMessage error;


  public ToflylinksException(String message){
    super(message);
    this.httpStatus = HttpStatus.BAD_REQUEST;
    this.error = ErrorMessage.INTERNAL_ERROR;
  }


  public ToflylinksException(ErrorMessage errorMessage) {
    super(errorMessage.getMessage());
    this.httpStatus = HttpStatus.BAD_REQUEST;
    this.error = errorMessage;
  }

  public ToflylinksException(ErrorMessage errorMessage, HttpStatus httpStatus) {
    super(errorMessage.getMessage());
    this.httpStatus = httpStatus;
    this.error = errorMessage;
  }

  public ToflylinksException() {
    super(ErrorMessage.INTERNAL_ERROR.getMessage());
    this.error = ErrorMessage.INTERNAL_ERROR;
    this.httpStatus = HttpStatus.INTERNAL_SERVER_ERROR;
  }
}
