package com.tofly.base.server.common.data.dto;

import com.tofly.base.server.common.data.common.DeleteGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.Set;

@Data
public class DeleteDTO {
  /** 删除主键IDS */
  @NotNull(
      message = "IDS不能为空",
      groups = {DeleteGroup.class})
  @Size(
      min = 1,
      message = "删除至少需要一个id",
      groups = {DeleteGroup.class})
  @ApiModelProperty(value = "删除ID列表", required = true)
  private Set<String> ids;

  @ApiModelProperty(value = "租户ID")
  private String tenantId;
}
