package com.tofly.base.server.common.data.dto;

import com.fasterxml.jackson.databind.JsonNode;
import com.tofly.base.server.common.data.common.aspect.annotation.AutoDict;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

@EqualsAndHashCode(callSuper = false)
@Data
public class MessageConfigDTO extends TenantDTO {

  @ApiModelProperty(value = "配置名称")
  private String configName;

  @ApiModelProperty(value = "短信平台类型")
  @AutoDict(dictCode = "platform_type")
  private String platformType;

  @ApiModelProperty(value = "消息类型")
  @AutoDict(dictCode = "message_type")
  private String messageType;

  @ApiModelProperty(value = "消息相关json配置")
  private JsonNode config;

  @ApiModelProperty(value = "状态：0禁用 1启用")
  private Integer status;

  @ApiModelProperty(value = "备注")
  private String remark;
}
