package com.tofly.base.server.common.data.dto;

import com.tofly.base.server.common.data.common.aspect.annotation.AutoDict;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

@EqualsAndHashCode(callSuper = false)
@Data
public class MessageTemplateDTO extends TenantDTO {
  @ApiModelProperty(value = "模板名称")
  private String templateName;

  @ApiModelProperty(value = "模板签名")
  private String signName;

  @ApiModelProperty(value = "模板CODE")
  private String templateCode;

  @ApiModelProperty(value = "消息配置")
  private String messageConfigId;

  @ApiModelProperty(value = "消息配置信息")
  private MessageConfigDTO messageConfig;

  @AutoDict(dictCode = "message_type")
  @ApiModelProperty(value = "消息类型")
  private String messageType;

  @AutoDict(dictCode = "template_purpose")
  @ApiModelProperty(value = "模板用途")
  private String templatePurpose;

  @ApiModelProperty(value = "状态：0禁用 1启用")
  private Integer status;
}
