package com.tofly.base.server.common.data.dto;

import com.tofly.base.server.common.data.utils.tree.TreeDTO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.ArrayList;
import java.util.List;

@EqualsAndHashCode(callSuper = true)
@Data
public class OrganizationDTO extends TenantDTO implements TreeDTO<OrganizationDTO> {
  @ApiModelProperty(value = "组织父ID")
  private String parentId;

  @ApiModelProperty(value = "组织名称")
  private String name;

  @ApiModelProperty(value = "排序")
  private int sort;

  @ApiModelProperty(value = "子集")
  private List<OrganizationDTO> children;

  @ApiModelProperty(value = "备注")
  private String remark;

  /** 部门管理人员**/
  @ApiModelProperty(value = "部门管理人员")
  private String adminUser;

  @ApiModelProperty(value = "部门管理人员")
  private String adminUsername;

  @ApiModelProperty(value = "钉钉编码")
  private String dingId;

  public OrganizationDTO() {
    this.children = new ArrayList<>();
  }

  @Override
  public int compareTo(OrganizationDTO o) {
    return this.getSort() - o.getSort();
  }
}
