package com.tofly.base.server.common.data.dto;

import com.fasterxml.jackson.annotation.JsonAlias;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;


@EqualsAndHashCode(callSuper = true)
@Data
public class RoleDTO extends TenantDTO {
  @ApiModelProperty(value = "角色名称")
  private String name;

  @ApiModelProperty(value = "备注")
  private String remark;

  @ApiModelProperty(value = "角色类型")
  private String roleType;

  @ApiModelProperty(value = "角色Code")
  private String code;

  @ApiModelProperty(value = "状态")
  @JsonFormat(shape = JsonFormat.Shape.NUMBER)
  @JsonAlias({"status", "enabled"})
  @JsonProperty("status")
  private boolean enabled = true;

  @ApiModelProperty(value = "角色ID列表")
  private String[] roleIds;
}
