package com.tofly.base.server.common.data.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import com.tofly.base.server.common.data.common.aspect.annotation.AutoDict;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

@EqualsAndHashCode(callSuper = true)
@Data
public class SmsLogDTO extends BaseDTO {
  @ApiModelProperty(value = "短信平台类型")
  @AutoDict(dictCode = "platform_type")
  private String type;

  @ApiModelProperty(value = "发送状态")
  private String status;

  @ApiModelProperty(value = "发送时间")
  @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
  @JsonSerialize(using = LocalDateTimeSerializer.class)
  private LocalDateTime sendTime;

  @ApiModelProperty(value = "发送手机号")
  private String toPhone;

  @ApiModelProperty(value = "发送模板参数")
  private JsonNode templateParam;

  @ApiModelProperty(value = "租户Code")
  private String tenantId;

  @ApiModelProperty(value = "模板用途")
  @AutoDict(dictCode = "template_purpose")
  private String templatePurpose;

  @ApiModelProperty(value = "备注")
  private String remark;

  @ApiModelProperty(value = "消息模板ID")
  private String messageTemplateId;
}
