package com.tofly.base.server.common.data.dto;

import com.tofly.base.server.common.data.enums.AreaLevelEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @author: 徐浩然
 * @desc: 中国省市区街关联
 * @date: 2021/12/16-15:03
 */
@Data
@ApiModel(value = "中国省市区街关联")
public class SysAreaDTO implements Serializable {
  @ApiModelProperty(value = "上级Code")
  private Long parentId;

  @ApiModelProperty(value = "行政级别：AreaLevelEnum")
  private AreaLevelEnum level;

  @ApiModelProperty(value = "行政名称")
  private String name;

  @ApiModelProperty(value = "行政编码")
  private Long code;
}
