package com.tofly.base.server.common.data.dto;

import com.tofly.base.entity.miniofile.File;
import com.tofly.base.server.common.data.common.AddGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Data
public class SysDictDTO extends BaseDTO {

    @ApiModelProperty(value = "字典名称")
    @NotEmpty(
            message = "字典名称不能为空或空字符串",
            groups = {AddGroup.class})
    private String dictName;

    @ApiModelProperty(value = "字典编码")
    @NotEmpty(
            message = "字典编码不能为空或空字符串",
            groups = {AddGroup.class})
    private String dictCode;

    @ApiModelProperty(value = "字典描述")
    private String description;

    @ApiModelProperty(value = "文件集合")
    private List<File> fileList;
}
