package com.tofly.base.server.common.data.dto;

import com.tofly.base.entity.miniofile.File;
import com.tofly.base.server.common.data.common.AddGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Data
public class SysDictItemDTO extends BaseDTO{
    @ApiModelProperty(value = "字典子项ID")
    private String dictId;

    @ApiModelProperty(value = "子项字典文本")
    @NotEmpty(message = "字典Item文本不能为空或空字符串",groups = {AddGroup.class})
    private String itemText;

    @ApiModelProperty(value = "子项字典值")
    @NotEmpty(message = "字典Item文本值不能为空或空字符串",groups = {AddGroup.class})
    private String itemValue;

    @ApiModelProperty(value = "子项字典描述")
    private String description;

    @ApiModelProperty(value = "子项字典排序")
    private Integer sort;

    @ApiModelProperty(value = "子项字典状态")
    private Integer status;

    @ApiModelProperty(value = "租户ID")
    private String tenantId;

    @ApiModelProperty(value = "字典信息")
    private SysDictDTO sysDict;

    @ApiModelProperty(value = "文件集合")
    private List<File> fileList;
}
