package com.tofly.base.server.common.data.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.RequiredArgsConstructor;

/**
 * @author: 徐浩然
 * @desc: 企业信息
 * @date: 2021/12/3-18:11
 */
@Data
@ApiModel(value = "企业信息")
@RequiredArgsConstructor
public class SysEnterpriseDTO extends BaseDTO {
  @ApiModelProperty(value = "公司名称")
  private String name;

  @ApiModelProperty(value = "公司简称")
  private String abbreviation;

  @ApiModelProperty(value = "公司官网")
  private String officialWebsite;

  @ApiModelProperty(value = "公司邮箱")
  private String email;

  @ApiModelProperty(value = "公司简介")
  private String synopsis;

  @ApiModelProperty(value = "详细地址")
  private String address;

  @ApiModelProperty(value = "联系人")
  private String contacts;

  @ApiModelProperty(value = "区号")
  private String area;

  @ApiModelProperty(value = "联系电话")
  private String tel;

  @ApiModelProperty(value = "区域信息")
  private AreaInfoDTO sysTown;

  @ApiModelProperty(value = "邮政编码")
  private Long codeTown;

  @ApiModelProperty(value = "二维码")
  private String qrCode;
}
