/**
 * Copyright © 2016-2022 The Thingsboard Authors
 *
 * <p>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of the License at
 *
 * <p>http://www.apache.org/licenses/LICENSE-2.0
 *
 * <p>Unless required by applicable law or agreed to in writing, software distributed under the
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.tofly.base.server.common.data.dto;

import com.fasterxml.jackson.databind.JsonNode;
import com.tofly.base.server.common.data.EntityType;
import com.tofly.base.server.common.data.enums.ActionStatus;
import com.tofly.base.server.common.data.enums.ActionType;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.UUID;

@EqualsAndHashCode(callSuper = true)
@Data
public class SysLogDTO extends BaseDTO {

  @ApiModelProperty(value = "操作时间")
  private long createdTime;

  private UUID tenantId;

  @ApiModelProperty(value = "租户名称")
  private String tenantName;

  private UUID customerId;

  @ApiModelProperty(value = "客户名称")
  private String customerName;

  @ApiModelProperty(value = "资源类型")
  private EntityType entityType;

  private UUID entityId;

  @ApiModelProperty(value = "资源名称")
  private String entityName;

  private UUID userId;

  @ApiModelProperty(value = "操作人员")
  private String userName;

  @ApiModelProperty(value = "操作类型")
  private ActionType actionType;

  @ApiModelProperty(value = "操作数据")
  private JsonNode actionData;

  @ApiModelProperty(value = "操作状态")
  private ActionStatus actionStatus;

  @ApiModelProperty(value = "失败信息")
  private String actionFailureDetails;
}
