package com.tofly.base.server.common.data.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import com.tofly.base.server.common.data.enums.TenantStatusEnum;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

@EqualsAndHashCode(callSuper = false)
@Data
public class TenantDTO extends BaseDTO {
  @ApiModelProperty(value = "租户名称")
  private String name;

  @ApiModelProperty(value = "租户图标")
  private String icon;

  @ApiModelProperty(value = "租户状态：启用/禁用")
  private boolean enabled;

  @ApiModelProperty(value = "租户描述")
  private String description;

  @ApiModelProperty(value = "租户默认配置")
  private String defaultConfig;

  @ApiModelProperty(value = "租户ID")
  private String tenantId;

  @ApiModelProperty(value = "租户角色列表")
  private String[] roleIds;

  @JsonInclude(JsonInclude.Include.NON_NULL)
  private TenantStatusEnum tenantStatus;

  @ApiModelProperty(value = "租户到期时间")
  @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
  @JsonSerialize(using = LocalDateTimeSerializer.class)
  private LocalDateTime tenantExpireTime;

  @ApiModelProperty(value = "租户配置")
  private String tenantProfileId;
}
