package com.tofly.base.server.common.data.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Set;

/** for authentication */
@EqualsAndHashCode(callSuper = true)
@Data
public class UserDetailsDTO extends BaseDTO implements Serializable {

  private static final long serialVersionUID = -515966143236266646L;

  @ApiModelProperty(value = "用户详情ID")
  private String id;

  @ApiModelProperty(value = "用户名")
  private String username;

  @ApiModelProperty(value = "用户密码")
  private String password;

  @ApiModelProperty(value = "用户状态")
  private boolean enabled;

  @ApiModelProperty(value = "用户账号过期时间")
  private LocalDateTime accountExpireTime;

  @ApiModelProperty(value = "租户信息")
  private TenantDTO tenant;

  @ApiModelProperty(value = "租户ID")
  private String tenantId;

  @ApiModelProperty(value = "用户角色详情列表")
  private Set<UserDetailRoleDTO> roles;
}
