package com.tofly.base.server.common.data.dto.request;

import com.tofly.base.server.common.data.constant.FastIotConstants;
import lombok.Data;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import java.util.LinkedHashMap;

@Data
public class SmsReqDTO {

  /** 模板参数 */
  private LinkedHashMap<String, String> params;

  /** 手机号码 */
  @Pattern(regexp = FastIotConstants.MOBILE, message = "请输入正确的手机号")
  private String phoneNumbers;

  /** 模板ID */
  @NotNull(message = "模板ID不能为空")
  private String id;

  /** 备注 */
  private String remark;

  /** 用途 */
  private String templatePurpose;
}
