/**
 * Copyright © 2016-2022 The Thingsboard Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.tofly.base.server.common.data.enums;

/**
 * Created by ashvayka on 11.05.17.
 */
public enum TkAlarmSeverity {
    CRITICAL("危险"), MAJOR("重要"), MINOR("次要"), WARNING("警告"), INDETERMINATE("不确定");

    TkAlarmSeverity(String label){
        this.label = label;
    }
    String label;

    public static String getLabel(String name){
        for(TkAlarmSeverity type:values()){
            if(type.name().equals(name)){
                return type.label;
            }
        }
        return null;
    }

}
