package com.tofly.base.server.common.data.utils;

import java.time.LocalDateTime;
import java.time.OffsetDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @version V1.0 @Description : 1.其它地方抛出异常，交由控制层统一处理 2.服务层注意持久化的事务管理 @Dependency: 依赖包 @Author:
 *     junlianglee @Date Created in 2021/12/28$ @Copyright 2016-2018 - Powered By 李唐源研发中心
 */
public class DateTimeUtils {
  public static final String PATTERN_DATE_FORMATE = "yyyy-MM-dd HH:mm:ss";

  public static String format(Long nacosTime) {
    if (nacosTime == null) {
      return null;
    }
    LocalDateTime createTime =
        LocalDateTime.ofEpochSecond(nacosTime / 1000, 0, OffsetDateTime.now().getOffset());
    return createTime.format(DateTimeFormatter.ofPattern(PATTERN_DATE_FORMATE));
  }
}
