package com.tofly.base.server.common.data.utils.tree;

import com.google.common.collect.Lists;
import com.google.common.collect.Sets;

import java.util.*;

public class TreeUtils {
  public static <T extends TreeDTO<T>> List<T> buildTree(List<T> treeList) {
    Map<String, T> dtoMap = new LinkedHashMap<>(treeList.size());
    LinkedHashSet<T> dtoSet = Sets.newLinkedHashSet(treeList);
    dtoSet.forEach(dto -> dtoMap.put(dto.getId(), dto));
    List<T> result = Lists.newArrayList();
    for (T node : dtoMap.values()) {
      T parent = dtoMap.get(node.getParentId());
      if (parent != null && !(node.getId().equals(parent.getId()))) {
        parent.getChildren().add(node);
        continue;
      }
      result.add(node);
    }
    Collections.sort(result);
    result.forEach(node -> Collections.sort(node.getChildren()));
    return result;
  }
}
