package com.tofly.base.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.tofly.base.entity.BaseEntity;
import com.tofly.base.server.common.data.enums.OrderTypeEnum;

import java.util.Collection;
import java.util.List;
import java.util.Set;

public interface BaseService<T extends BaseEntity>{
  List<T> findAllByTenant(String tenantId);

  boolean deleteDataByTenantIds(Set<String> tenantIds);

  boolean insertBatch(Collection<T> entityList, int batchSize);
  IPage<T> getPage(Integer pageNum, Integer pageSize, String orderField, OrderTypeEnum orderType);
}
