package com.tofly.base.service.appdesign.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.tofly.base.entity.appdesign.SysAppDesignEntity;
import com.tofly.base.mapper.appdesign.SysAppDesignMapper;
import com.tofly.base.server.common.data.constant.FastIotConstants;
import com.tofly.base.server.common.data.dto.SysAppDesignDTO;
import com.tofly.base.service.AbstractBaseService;
import com.tofly.base.service.appdesign.SysAppDesignService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @author: 徐浩然
 * @desc: APP定制
 * @date: 2021/12/3-18:40
 */
@Slf4j
@Service
@RequiredArgsConstructor
public class SysAppDesignServiceImpl extends AbstractBaseService<SysAppDesignMapper, SysAppDesignEntity>
    implements SysAppDesignService {
  @Override
  public boolean save(SysAppDesignDTO sysAppDesignDTO, String tenantId) {
    if (get(tenantId) != null) {
      return false;
    }
    SysAppDesignEntity entity = sysAppDesignDTO.getEntity(SysAppDesignEntity.class);
    entity.setTenantId(tenantId);
    return baseMapper.insert(entity) > FastIotConstants.MagicNumber.ZERO;
  }

  @Override
  public SysAppDesignDTO get(String tenantId) {
    SysAppDesignEntity sysAppDesign =
        baseMapper.selectOne(
            new LambdaQueryWrapper<SysAppDesignEntity>().eq(SysAppDesignEntity::getTenantId, tenantId));
    return sysAppDesign == null ? null : sysAppDesign.getDTO(SysAppDesignDTO.class);
  }

  @Override
  public boolean update(SysAppDesignDTO sysAppDesignDTO, String tenantId) {
    if (get(tenantId) != null) {
      return baseMapper.update(
              sysAppDesignDTO.getEntity(SysAppDesignEntity.class),
              new LambdaQueryWrapper<SysAppDesignEntity>().eq(SysAppDesignEntity::getTenantId, tenantId))
          > FastIotConstants.MagicNumber.ZERO;
    } else {
      return save(sysAppDesignDTO, tenantId);
    }
  }

  @Override
  public boolean factoryDataReset(String tenantId) {
    return baseMapper.delete(
            new LambdaQueryWrapper<SysAppDesignEntity>().eq(SysAppDesignEntity::getTenantId, tenantId))
        > FastIotConstants.MagicNumber.ZERO;
  }
}
