package com.tofly.base.service.dic;


import com.tofly.base.server.common.data.dto.SysDictItemDTO;
import com.tofly.base.server.common.data.utils.tools.TkPageData;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;
import java.util.Set;

public interface SysDictItemService {
    TkPageData<SysDictItemDTO> page(Map<String, Object> queryMap);

    SysDictItemDTO saveSysDictItem(HttpServletRequest servletRequest, SysDictItemDTO sysDictItemDTO, String tenantId);

    boolean deleteSysDictItem(Set<String> sysDictItemIds);

    List<String> findDictCodeByIds(Set<String> sysDictItemIds);

    SysDictItemDTO updateSysDictItem(HttpServletRequest servletRequest, SysDictItemDTO sysDictItemDTO,String tenantId);

    /**
     * 查询字典code对应的所有字典值
     * @param dictCode 字典code
     * @return List<SysDictItemDTO>
     */
    List<SysDictItemDTO> findDictItemByDictCode(String dictCode);
}
