package com.tofly.base.service.log.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.tofly.base.entity.log.SysLogEntity;
import com.tofly.base.mapper.log.SysLogMapper;
import com.tofly.base.server.common.data.EntityType;
import com.tofly.base.server.common.data.dto.SysLogDTO;
import com.tofly.base.server.common.data.enums.ActionType;
import com.tofly.base.server.common.data.utils.tools.TkPageData;
import com.tofly.base.service.AbstractBaseService;
import com.tofly.base.service.log.TkSysLogService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Slf4j
@Service
@RequiredArgsConstructor
public class SysLogServiceImpl extends AbstractBaseService<SysLogMapper, SysLogEntity>
        implements TkSysLogService {


    @Override
    public SysLogDTO detail(String entityId) {
        return baseMapper.detailById(entityId);
    }

    @Override
    public TkPageData<SysLogDTO> exceptionPage(IPage<SysLogEntity> pageInfrom, Long startTime, Long endTime, String tenantId, String customerId, ActionType actionType) {
        IPage<SysLogDTO> page =
                baseMapper.getPageDatasMatched(pageInfrom, tenantId, customerId, startTime, endTime, EntityType.RUNNING_EXCEPTION, actionType);
        return getPageData(page, SysLogDTO.class);
    }


    @Override
    public TkPageData<SysLogDTO> operatePage(IPage<SysLogEntity> pageInfrom, Long startTime, Long endTime, String tenantId, String customerId, EntityType entityType, ActionType actionType) {
        List<EntityType> entityTypes = new ArrayList<>();
        entityTypes.add(EntityType.BACKUP);
        entityTypes.add(EntityType.RUNNING_EXCEPTION);
        entityTypes.add(EntityType.USER);
        entityTypes.add(EntityType.ALARM);
        entityTypes.add(EntityType.RULE_CHAIN);
        entityTypes.add(EntityType.RULE_NODE);
        entityTypes.add(EntityType.ENTITY_VIEW);
        entityTypes.add(EntityType.WIDGETS_BUNDLE);
        entityTypes.add(EntityType.WIDGET_TYPE);
        entityTypes.add(EntityType.DASHBOARD);
        entityTypes.add(EntityType.ASSET);
        entityTypes.add(EntityType.API_USAGE_STATE);
        entityTypes.add(EntityType.TB_RESOURCE);
        entityTypes.add(EntityType.OTA_PACKAGE);
        entityTypes.add(EntityType.EDGE);
        entityTypes.add(EntityType.RPC);

        IPage<SysLogDTO> page =
                baseMapper.getPageDatasNot(pageInfrom, tenantId, customerId, startTime, endTime, entityType, actionType, entityTypes);
        return getPageData(page, SysLogDTO.class);
    }

    @Override
    public TkPageData<SysLogDTO> loginPage(IPage<SysLogEntity> pageInfrom, Long startTime, Long endTime, String tenantId, String customerId, ActionType actionType) {
        IPage<SysLogDTO> page =
                baseMapper.getPageDatasMatched(pageInfrom, tenantId, customerId, startTime, endTime, EntityType.USER, actionType);
        return getPageData(page, SysLogDTO.class);
    }

    @Override
    public TkPageData<SysLogDTO> backupLogPage(IPage<SysLogEntity> pageInfrom, Long startTime, Long endTime, String tenantId, String customerId, ActionType actionType) {
        IPage<SysLogDTO> page =
                baseMapper.getPageDatasMatched(pageInfrom, tenantId, customerId, startTime, endTime, EntityType.BACKUP, actionType);
        return getPageData(page, SysLogDTO.class);
    }

}
