package com.tofly.base.service.menu;

import com.tofly.base.server.common.data.dto.MenuDTO;

import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.Set;

public interface MenuService {
  /**
   * sysadmin获取所有的menu，但是不获取租户自己创建的menu
   *
   * @return list 树状menu
   */
  List<MenuDTO>
  getAllMenus(String tenantId);

  /**
   * 获取自己的menu, 如果是tenant admin, 获取已分配的所有菜单，如果是普通用户，获取自己被租户管理员分配的菜单
   *
   * @return list 树状menu
   */
  List<MenuDTO> getMyMenus(
      String tenantId, String userId, boolean isPtSysAdmin, boolean isPtTenantAdmin,boolean needButton, boolean needField);



  List<MenuDTO> getButtons(String userId);


  MenuDTO saveMenu(MenuDTO menuDTO);

  Optional<MenuDTO> getMenu(String id);

  MenuDTO updateMenu(MenuDTO menuDTO);

  boolean deleteMenus(String tenantId, String[] ids);

  boolean assignMenuToTenant(String tenantId, String[] menuId);

  boolean assignMenuToRole(String[] menuId, String roleId);

  Set<String> getMenuIdsByRoleId(String roleId);
  /**
   * 安全测评加入
   * @param ids
   * @return
   */
  Map<String, String> findMenuMap(String[] ids);
}
