package com.tofly.base.service.miniofile;

import com.tofly.base.server.common.data.dto.FileUploadResponse;
import org.springframework.http.ResponseEntity;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;

public interface FileStorageService {

    /**
     * 上传文件
     *
     * @param file 待上传文件
     * @return {@link FileUploadResponse} 实例对象
     */

    FileUploadResponse upload(MultipartFile file, String Path);

    /**
     * 下载文件
     *
     * @param fileName 待下载文件名
     * @param response {@link HttpServletResponse}
     */
    ResponseEntity<?> download(
            String fileName, HttpServletRequest request, HttpServletResponse response);


    String uploadFile(String Path, String fileName, String contentType, InputStream inputStream)
            throws IOException;

    void removeFile(String PathfileName) throws IOException;

}
