package com.tofly.base.service.organization;

import com.tofly.base.ding.base.entity.DingDeptVo;
import com.tofly.base.entity.organization.TkOrganizationEntity;
import com.tofly.base.server.common.data.dto.DeleteDTO;
import com.tofly.base.server.common.data.dto.OrganizationDTO;
import com.tofly.base.service.BaseService;

import java.util.List;
import java.util.Map;
import java.util.Set;

public interface TkOrganizationService extends BaseService<TkOrganizationEntity> {
  OrganizationDTO saveOrganization(OrganizationDTO organizationDTO, String tenantId, boolean isCustomerOrPlatform, String userId);

  boolean deleteOrganizations(DeleteDTO deleteDTO, String tenantId);

  List<OrganizationDTO> getMyOrganizations(
          boolean isPtSysAdmin,boolean isPtTenantAdmin, String tenantId, String currentUserId);

  OrganizationDTO updateOrganization(OrganizationDTO organizationDTO, String tenantId,boolean isCustomerOrPlatform,String userId);

  void bindUserToOrganization(String tenantId, String userId, String[] organizationIds);

  void unBindUserToOrganization(Set<String> userIds);

  OrganizationDTO findOrganizationById(String id,String tenantId);
  /**
   * 安全测评加入
   * @param ids
   * @return
   */
  Map<String, String> findOrganizationMap(Set<String> ids);

  /**
   * 存入从钉钉拉取的部门数据
   * @param list
   */
  void saveOrUpdateOrganizationByDingDept(List<DingDeptVo> list);

    List<String> getChildrenId(String id);

  List<String> getByUserId(String userId);

  List<TkOrganizationEntity> getAllOrganization();

}
