package com.tofly.base.service.platform.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.tofly.base.entity.platform.SysPlatformDesignEntity;
import com.tofly.base.mapper.platform.SysPlatformDesignMapper;
import com.tofly.base.server.common.data.constant.FastIotConstants;
import com.tofly.base.server.common.data.dto.SysPlatformDesignDTO;
import com.tofly.base.service.AbstractBaseService;
import com.tofly.base.service.platform.SysPlatformDesignService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @author: 徐浩然
 * @desc: 平台定制
 * @date: 2021/12/3-18:41
 */
@Slf4j
@Service
@RequiredArgsConstructor
public class SysPlatformDesignServiceImpl
    extends AbstractBaseService<SysPlatformDesignMapper, SysPlatformDesignEntity>
    implements SysPlatformDesignService {
  @Override
  public boolean save(SysPlatformDesignDTO sysAppDesignDTO, String tenantId) {
    SysPlatformDesignEntity entity = sysAppDesignDTO.getEntity(SysPlatformDesignEntity.class);
    entity.setTenantId(tenantId);
    return baseMapper.insert(entity) > 0;
  }

  @Override
  public SysPlatformDesignDTO get(String tenantId) {
    SysPlatformDesignEntity sysPlatformDesign =
        baseMapper.selectOne(
            new LambdaQueryWrapper<SysPlatformDesignEntity>()
                .eq(SysPlatformDesignEntity::getTenantId, tenantId));
    return sysPlatformDesign == null ? null : sysPlatformDesign.getDTO(SysPlatformDesignDTO.class);
  }

  @Override
  public boolean update(SysPlatformDesignDTO sysAppDesignDTO, String tenantId) {
    if (get(tenantId) != null) {
      return baseMapper.update(
              sysAppDesignDTO.getEntity(SysPlatformDesignEntity.class),
              new LambdaQueryWrapper<SysPlatformDesignEntity>()
                  .eq(SysPlatformDesignEntity::getTenantId, tenantId))
          > 0;
    } else {
      return save(sysAppDesignDTO, tenantId);
    }
  }

  @Override
  public boolean factoryDataReset(String tenantId) {
    return baseMapper.delete(
            new LambdaQueryWrapper<SysPlatformDesignEntity>()
                .eq(SysPlatformDesignEntity::getTenantId, tenantId))
        > FastIotConstants.MagicNumber.ZERO;
  }
}
