package com.tofly.base.service.role;


import com.tofly.base.server.common.data.core.exception.TkDataValidationException;
import com.tofly.base.server.common.data.dto.RoleDTO;
import com.tofly.base.server.common.data.dto.request.RoleReqDTO;
import com.tofly.base.server.common.data.utils.tools.TkPageData;

import java.util.List;
import java.util.Map;
import java.util.Set;

public interface RoleService {
  TkPageData<RoleDTO> page(String tenantId, Map<String, Object> queryMap);

  boolean deleteRole(String[] roleIds,String tenantId);

  Set<String> getPermissions(boolean isSysadmin,boolean isTenantAdmin,String tenantId,String useerId);

  void updateRoleStatus(String roleId, int status,boolean isSysadmin,String tenantId);

  RoleDTO saveOrUpdateRoleInfoWithMenu(RoleReqDTO roleReqDTO, boolean isSysadmin, boolean isPlatformAdmin, String tenantId) throws TkDataValidationException;

  /**
   * 查询所有的角色信息
   * @param roleDTO 过滤条件
   * @return 所有角色信息
   */
  List<RoleDTO> findRoleInfo(boolean isTenantAdmin,String tenantId,String userId,RoleDTO roleDTO);

  /**
   * 安全测评加入
   * @param ids
   * @return
   */
  Map<String, String> findRoleMap(String[] ids);

    Boolean getHasRoleByUserId(String userID, String roleName);
}
