package com.tofly.base.service.role.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.tofly.base.entity.role.SysRolePermission;
import com.tofly.base.mapper.role.RolePermissionMapper;
import com.tofly.base.service.AbstractBaseService;
import com.tofly.base.service.role.RolePermissionService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
@Slf4j
@RequiredArgsConstructor
public class RolePsrmissionServiceImpl  extends AbstractBaseService<RolePermissionMapper, SysRolePermission> implements RolePermissionService  {

	@Override
	public boolean updateRolePermission(Map<String, String> rolePermissionMap) {
		
		String roleId = rolePermissionMap.get("roleId");
		baseMapper.delete(new QueryWrapper<SysRolePermission>()
                .lambda()
                .eq(SysRolePermission::getRoleId, roleId));
		
		for (String key : rolePermissionMap.keySet()) {
			switch(key) {
				case "segments":{
					 String records = rolePermissionMap.get(key);
					 String[] ids = records.split(",");
					 for(String dataId: ids) {
						 SysRolePermission srp =new SysRolePermission();
						 srp.setPermissionType("segments");
						 srp.setRoleId(roleId);
						 srp.setDataId(dataId);
						 srp.setCreator("");
						 srp.setCreateTime(new Date());
						 baseMapper.insert(srp);
					 }
					 break;
				}
				case "projects":{
					 String records = rolePermissionMap.get(key);
					 String[] ids = records.split(",");
					 for(String dataId: ids) {
						 SysRolePermission srp =new SysRolePermission();
						 srp.setPermissionType("projects");
						 srp.setRoleId(roleId);
						 srp.setDataId(dataId);
						 srp.setCreator("");
						 srp.setCreateTime(new Date());
						 baseMapper.insert(srp);
					 }
					 break;
				}
				case "monitors":{
					 String records = rolePermissionMap.get(key);
					 String[] ids = records.split(",");
					 for(String dataId: ids) {
						 SysRolePermission srp =new SysRolePermission();
						 srp.setPermissionType("monitors");
						 srp.setRoleId(roleId);
						 srp.setDataId(dataId);
						 srp.setCreator("");
						 srp.setCreateTime(new Date());
						 baseMapper.insert(srp);
					 }
					 break;
				}
				case "devices":{
					 String records = rolePermissionMap.get(key);
					 String[] ids = records.split(",");
					 for(String dataId: ids) {
						 SysRolePermission srp =new SysRolePermission();
						 srp.setPermissionType("devices");
						 srp.setRoleId(roleId);
						 srp.setDataId(dataId);
						 srp.setCreator("");
						 srp.setCreateTime(new Date());
						 baseMapper.insert(srp);
					 }
					 break;
				}
				case "sensors":{
					 String records = rolePermissionMap.get(key);
					 String[] ids = records.split(",");
					 for(String dataId: ids) {
						 SysRolePermission srp =new SysRolePermission();
						 srp.setPermissionType("sensors");
						 srp.setRoleId(roleId);
						 srp.setDataId(dataId);
						 srp.setCreator("");
						 srp.setCreateTime(new Date());
						 baseMapper.insert(srp);
					 }
					 break;
				}
				case "multiDatas":{
					 String records = rolePermissionMap.get(key);
					 String[] ids = records.split(",");
					 for(String dataId: ids) {
						 SysRolePermission srp =new SysRolePermission();
						 srp.setPermissionType("multiDatas");
						 srp.setRoleId(roleId);
						 srp.setDataId(dataId);
						 srp.setCreator("");
						 srp.setCreateTime(new Date());
						 baseMapper.insert(srp);
					 }
					 break;
				}
				case "rtus":{
					 String records = rolePermissionMap.get(key);
					 String[] ids = records.split(",");
					 for(String dataId: ids) {
						 SysRolePermission srp =new SysRolePermission();
						 srp.setPermissionType("rtus");
						 srp.setRoleId(roleId);
						 srp.setDataId(dataId);
						 srp.setCreator("");
						 srp.setCreateTime(new Date());
						 baseMapper.insert(srp);
					 }
					 break;
				}
				default :{
					 break;	
				}
			}
        }
		return true;
	}

	@Override
	public List<Map<String, String>> getRolePermissionByRoleId(String roleId) {
		return baseMapper.getRolePermissionByRoleId(roleId);
	}

	@Override
	public List<Map<String, String>> getRolePermissionByUserId(String userId) {
		return baseMapper.getRolePermissionByUserId(userId);
	}

}
