//package com.tofly.base.service.user.impl;
//
//import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
//import com.baomidou.mybatisplus.core.metadata.IPage;
//import lombok.RequiredArgsConstructor;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.commons.lang3.StringUtils;
//import org.springframework.stereotype.Service;
//import org.springframework.transaction.annotation.Transactional;
//import org.thingsboard.server.common.data.yunteng.constant.FastIotConstants;
//import org.thingsboard.server.common.data.yunteng.core.exception.TkDataValidationException;
//import org.thingsboard.server.common.data.yunteng.core.message.ErrorMessage;
//import org.thingsboard.server.common.data.yunteng.dto.MessageConfigDTO;
//import org.thingsboard.server.common.data.yunteng.utils.ReflectUtils;
//import org.thingsboard.server.common.data.yunteng.utils.tools.TkPageData;
//import org.thingsboard.server.dao.yunteng.entities.TkMessageConfigEntity;
//import org.thingsboard.server.dao.yunteng.mapper.MessageConfigMapper;
//import org.thingsboard.server.dao.yunteng.service.AbstractBaseService;
//import org.thingsboard.server.dao.yunteng.service.TkMessageConfigService;
//
//import java.util.List;
//import java.util.Map;
//import java.util.Set;
//
//@Service
//@Slf4j
//@RequiredArgsConstructor
//public class TkMessageConfigServiceImpl
//    extends AbstractBaseService<MessageConfigMapper, TkMessageConfigEntity>
//    implements TkMessageConfigService {
//
//  @Override
//  public TkPageData<MessageConfigDTO> page(String tenantId, Map<String, Object> queryMap) {
//    IPage<TkMessageConfigEntity> configIPage =
//        baseMapper.selectPage(
//            getPage(queryMap, "create_time", false),
//            new QueryWrapper<TkMessageConfigEntity>()
//                .lambda()
//                .eq(
//                    queryMap.get("platformType") != null,
//                    TkMessageConfigEntity::getPlatformType,
//                    String.valueOf(queryMap.get("platformType")))
//                .eq(
//                    queryMap.get("messageType") != null,
//                    TkMessageConfigEntity::getMessageType,
//                    String.valueOf(queryMap.get("messageType")))
//                .eq(
//                    queryMap.get("status") != null,
//                    TkMessageConfigEntity::getStatus, queryMap.get("status"))
//                .eq(true, TkMessageConfigEntity::getTenantId, tenantId));
//    return getPageData(configIPage, MessageConfigDTO.class);
//  }
//
//  @Override
//  @Transactional
//  public MessageConfigDTO saveMessageConfig(String tenantId, MessageConfigDTO configDTO) {
//    // 如果状态为停用
//    if (configDTO.getStatus() == FastIotConstants.StateValue.ENABLE) {
//      checkMessageConfig(configDTO, tenantId);
//    }
//    TkMessageConfigEntity config = new TkMessageConfigEntity();
//    configDTO.copyToEntity(config);
//    config.setTenantId(tenantId);
//    baseMapper.insert(config);
//    config.copyToDTO(configDTO);
//    return configDTO;
//  }
//
//  @Override
//  @Transactional
//  public boolean deleteMessageConfig(Set<String> ids) {
//    return baseMapper.deleteBatchIds(ids) > 0;
//  }
//
//  @Override
//  @Transactional
//  public MessageConfigDTO updateMessageConfig(String tenantId, MessageConfigDTO configDTO) {
//    TkMessageConfigEntity config = baseMapper.selectById(configDTO.getId());
//    if (configDTO.getStatus() == FastIotConstants.StateValue.ENABLE) {
//      if (StringUtils.isEmpty(config.getId())) {
//        throw new TkDataValidationException("invalid parameters");
//      }
//      checkMessageConfig(configDTO, tenantId);
//    }
//    configDTO.copyToEntity(config);
//    config.setTenantId(tenantId);
//    baseMapper.updateById(config);
//    config.copyToDTO(configDTO);
//    return configDTO;
//  }
//
//  /**
//   * 通过租户Code、消息类型和平台类型获取启用的配置
//   *
//   * @param messageType 消息类型
//   * @param platform 平台类型
//   * @param tenantId 租户Code
//   * @return 启用的配置信息
//   */
//  @Override
//  public MessageConfigDTO getEnableConfigByMessageAndPlatform(
//      String messageType, String platform, String tenantId) {
//    return baseMapper.getEnableConfigByMessageAndPlatform(messageType, platform, tenantId);
//  }
//
//  /**
//   * 通过ID查询MessageConfig信息
//   *
//   * @param id 主键ID
//   * @return 返回类型：MessageConfigDTO
//   */
//  @Override
//  public MessageConfigDTO findMessageConfigById(String id) {
//    MessageConfigDTO messageConfigDTO = new MessageConfigDTO();
//    TkMessageConfigEntity messageConfig = baseMapper.selectById(id);
//    if (null == messageConfig) {
//      return null;
//    }
//    messageConfig.copyToDTO(messageConfigDTO);
//    return messageConfigDTO;
//  }
//
//  @Override
//  public List<MessageConfigDTO> findMessageInfo(MessageConfigDTO configDTO) {
//    return ReflectUtils.sourceToTarget(
//        baseMapper.selectList(
//            new QueryWrapper<TkMessageConfigEntity>()
//                .lambda()
//                .eq(
//                    configDTO.getMessageType() != null,
//                    TkMessageConfigEntity::getMessageType,
//                    configDTO.getMessageType())
//                .eq(TkMessageConfigEntity::getTenantId, configDTO.getTenantId())),
//        MessageConfigDTO.class);
//  }
//
//  /**
//   * 检查MessageConfig状态
//   *
//   * @param configDTO MessageConfig配置
//   * @param tenantId 租户Code
//   */
//  private void checkMessageConfig(MessageConfigDTO configDTO, String tenantId) {
//    // 查询该租户下是否有相同消息类型和平台的配置已经启用
//    MessageConfigDTO enableConfig =
//        getEnableConfigByMessageAndPlatform(
//            configDTO.getMessageType(), configDTO.getPlatformType(), tenantId);
//    if (null != enableConfig && !enableConfig.getId().equalsIgnoreCase(configDTO.getId())) {
//      throw new TkDataValidationException(ErrorMessage.ENABLED_CONFIG_IS_EXISTED.getMessage());
//    }
//  }
//}
