//package com.tofly.base.service.user.impl;
//
//import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
//import com.fasterxml.jackson.databind.JsonNode;
//import com.fasterxml.jackson.databind.node.ObjectNode;
//import com.tofly.base.entity.user.SysUserEntity;
//import com.tofly.base.entity.user.TkMessageConfigEntity;
//import com.tofly.base.entity.user.TkMessageTemplateEntity;
//import com.tofly.base.entity.user.TkSmsLogEntity;
//import com.tofly.base.mapper.user.MessageConfigMapper;
//import com.tofly.base.mapper.user.MessageTemplateMapper;
//import com.tofly.base.mapper.user.SmsLogMapper;
//import com.tofly.base.mapper.user.UserMapper;
//import com.tofly.base.server.common.data.core.cache.CacheUtils;
//import com.tofly.base.server.common.data.core.exception.TkDataValidationException;
//import com.tofly.base.server.common.data.core.message.ErrorMessage;
//import com.tofly.base.server.common.data.dto.request.SmsReqDTO;
//import com.tofly.base.server.common.data.enums.AssetStatusEnum;
//import com.tofly.base.server.common.data.enums.MessageTypeEnum;
//import com.tofly.base.server.common.data.enums.MsgTemplatePurposeEnum;
//import com.tofly.base.server.common.data.enums.ResponseCodeEnum;
//import com.tofly.base.server.common.data.enums.SmsProviderTypeEnum;
//import com.tofly.base.server.common.data.utils.JacksonUtil;
//import com.tofly.base.service.user.TkSmsService;
//
//import lombok.RequiredArgsConstructor;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.commons.lang3.RandomStringUtils;
//import org.apache.commons.lang3.StringUtils;
//import org.springframework.stereotype.Service;
//import org.springframework.transaction.annotation.Transactional;
//
//
//
//import java.time.LocalDateTime;
//import java.util.LinkedHashMap;
//import java.util.List;
//
//
//
//@Slf4j
//@Service
//@RequiredArgsConstructor
//public class TkSmsServiceImpl implements TkSmsService {
//
//  private final MessageTemplateMapper messageTemplateMapper;
//
//  private final MessageConfigMapper messageConfigMapper;
//
//  private final TkDefaultSmsSenderFactory tkDefaultSmsSenderFactory;
//
//  private final SmsLogMapper smsLogMapper;
//
//  private final CacheUtils cacheUtils;
//
//  private final UserMapper userMapper;
//
//  @Override
//  @Transactional
//  public boolean sendSms(SmsReqDTO smsReqDTO) {
//    String phoneNumbers = smsReqDTO.getPhoneNumbers();
//    LinkedHashMap<String, String> templateParam = smsReqDTO.getParams();
//    String templateId = smsReqDTO.getId();
//    if (StringUtils.isEmpty(phoneNumbers) || StringUtils.isEmpty(templateId)) {
//      throw new TkDataValidationException(ErrorMessage.INVALID_PARAMETER.getMessage());
//    }
//    /** 消息模板是否可用 */
//    QueryWrapper<TkMessageTemplateEntity> messageTemplateQueryWrapper =
//        new QueryWrapper<TkMessageTemplateEntity>();
//    messageTemplateQueryWrapper
//        .lambda()
//        .eq(TkMessageTemplateEntity::getId, templateId)
//        .eq(TkMessageTemplateEntity::getStatus, AssetStatusEnum.ENABLE.ordinal());
//    TkMessageTemplateEntity messageTemplate =
//        messageTemplateMapper.selectOne(messageTemplateQueryWrapper);
//    if (null == messageTemplate) {
//      throw new TkDataValidationException(ErrorMessage.MESSAGE_TEMPLATE_NOT_EXISTS.getMessage());
//    }
//
//    /** 消息配置是否可用 */
//    QueryWrapper<TkMessageConfigEntity> configQueryWrapper = new QueryWrapper<>();
//    configQueryWrapper
//        .lambda()
//        .eq(TkMessageConfigEntity::getId, messageTemplate.getMessageConfigId())
//        .eq(TkMessageConfigEntity::getStatus, AssetStatusEnum.ENABLE.ordinal());
//    TkMessageConfigEntity messageConfig = messageConfigMapper.selectOne(configQueryWrapper);
//    if (null == messageConfig) {
//      throw new TkDataValidationException(ErrorMessage.MESSAGE_CONFIG_NOT_EXISTS.getMessage());
//    }
//
//    JsonNode configJsonNode = messageConfig.getConfig();
//    ObjectNode configObjectNode = (ObjectNode) configJsonNode;
//    String platForm = messageConfig.getPlatformType();
//    configObjectNode.put("type", platForm);
//    boolean isMatch = true;
//    if (platForm.equals(SmsProviderTypeEnum.TENCENT_CLOUD.name())
//        && (null == configJsonNode.get("appId") || null == configJsonNode.get("appKey"))) {
//      isMatch = false;
//    } else if (platForm.equals(SmsProviderTypeEnum.ALI_CLOUD.name())
//        && (null == configJsonNode.get("accessKeyId")
//            || null == configJsonNode.get("accessKeySecret"))) {
//      isMatch = false;
//    }
//    if (!isMatch) {
//      throw new TkDataValidationException(ErrorMessage.SMS_CONFIG_ERROR.getMessage());
//    }
//    SmsProviderConfiguration smsProviderConfiguration =
//        JacksonUtil.convertValue(configObjectNode, SmsProviderConfiguration.class);
//    if (null != smsProviderConfiguration) {
//      SmsSender smsSender = tkDefaultSmsSenderFactory.createSmsSender(smsProviderConfiguration);
//      String result =
//          smsSender.sendSms(
//              phoneNumbers,
//              messageTemplate.getTemplateCode(),
//              templateParam,
//              messageTemplate.getSignName());
//      // 记录短信日志
//      String status = ResponseCodeEnum.SUCCESS.name();
//      String remark = smsReqDTO.getRemark() == null ? "" : smsReqDTO.getRemark();
//      if (!ResponseCodeEnum.SUCCESS.name().equals(result)) {
//        status = ResponseCodeEnum.FAILED.name();
//        remark += result;
//      }
//      TkSmsLogEntity smsLog = new TkSmsLogEntity();
//      smsLog.setToPhone(phoneNumbers);
//      smsLog.setType(messageConfig.getPlatformType());
//      smsLog.setStatus(status);
//      smsLog.setRemark(remark);
//      smsLog.setMessageTemplateId(messageTemplate.getId());
//      smsLog.setTemplateParam(JacksonUtil.toJsonNode(JacksonUtil.toString(templateParam)));
//      smsLog.setSendTime(LocalDateTime.now());
//      smsLog.setTenantId(messageTemplate.getTenantId());
//      smsLog.setTemplatePurpose(smsReqDTO.getTemplatePurpose());
//      smsLogMapper.insert(smsLog);
//      return ResponseCodeEnum.SUCCESS.name().equals(result);
//    }
//    return false;
//  }
//
//  @Override
//  @Transactional
//  public boolean sendSmsCode(String phoneNumber, MsgTemplatePurposeEnum purpose) {
//    // 检查手机号码是否存在系统，以免乱发消息
//    List<SysUserEntity> users =
//        userMapper.selectList(
//            new QueryWrapper<SysUserEntity>()
//                .lambda()
//                .eq(SysUserEntity::getPhoneNumber, phoneNumber));
//    if (users.isEmpty()) {
//      throw new TkDataValidationException("电话号码未在系统注册，请联系你的管理员");
//    }
//    if (users.get(0).getAccountExpireTime() != null
//        && users.get(0).getAccountExpireTime().isBefore(LocalDateTime.now())) {
//      throw new TkDataValidationException(ErrorMessage.ACCOUNT_HAS_EXPIRED.getMessage());
//    }
//    // 获取是否有验证码存在，防止发送数量过多
//    String key =
//        purpose.name()
//            + DEFAULT_DELIMITER
//            + MessageTypeEnum.PHONE_MESSAGE.name()
//            + DEFAULT_DELIMITER
//            + phoneNumber;
//    boolean canSend =
//        cacheUtils
//            .get(MOBILE_LOGIN_SMS_CODE, key)
//            .map(
//                o -> {
//                  CodeTTL codeTTL = (CodeTTL) o;
//                  return System.currentTimeMillis() - codeTTL.getSendTs()
//                      >= 60 * 1000; // 大于1分钟才允许下次再发送短信
//                })
//            .orElse(true);
//    if (!canSend) {
//      throw new TkDataValidationException(ErrorMessage.MESSAGE_SEND_TOO_FAST.getMessage());
//    }
//
//    /** 消息模板是否可用 */
//    List<TkMessageTemplateEntity> messageTemplates =
//        messageTemplateMapper.selectList(
//            new QueryWrapper<TkMessageTemplateEntity>()
//                .lambda()
//                .eq(TkMessageTemplateEntity::getTenantId, users.get(0).getTenantId())
//                .eq(TkMessageTemplateEntity::getStatus, 1)
//                .eq(TkMessageTemplateEntity::getTemplatePurpose, purpose.name())
//                .eq(TkMessageTemplateEntity::getMessageType, MessageTypeEnum.PHONE_MESSAGE.name()));
//    if (messageTemplates.isEmpty()) {
//      throw new TkDataValidationException(ErrorMessage.MESSAGE_TEMPLATE_NOT_EXISTS.getMessage());
//    }
//
//    /** 消息配置是否可用 */
//    TkMessageTemplateEntity messageTemplate = messageTemplates.get(0);
//    QueryWrapper<TkMessageConfigEntity> configQueryWrapper = new QueryWrapper<>();
//    configQueryWrapper
//        .lambda()
//        .eq(TkMessageConfigEntity::getId, messageTemplate.getMessageConfigId())
//        .eq(TkMessageConfigEntity::getStatus, AssetStatusEnum.ENABLE.ordinal());
//    TkMessageConfigEntity messageConfig = messageConfigMapper.selectOne(configQueryWrapper);
//    if (null == messageConfig) {
//      throw new TkDataValidationException(ErrorMessage.MESSAGE_CONFIG_NOT_EXISTS.getMessage());
//    }
//
//    String code = RandomStringUtils.randomNumeric(6);
//    LinkedHashMap<String, String> params = new LinkedHashMap<>();
//    params.put("code", code);
//    SmsReqDTO smsReqDTO = new SmsReqDTO();
//    smsReqDTO.setParams(params);
//    smsReqDTO.setPhoneNumbers(phoneNumber);
//    smsReqDTO.setId(messageTemplate.getId());
//    smsReqDTO.setTemplatePurpose(purpose.name());
//    if (this.sendSms(smsReqDTO)) {
//      cacheUtils.put(MOBILE_LOGIN_SMS_CODE, key, new CodeTTL(code, System.currentTimeMillis()));
//      return true;
//    } else {
//      cacheUtils.invalidate(MOBILE_LOGIN_SMS_CODE, key);
//      return false;
//    }
//  }
//}
