package com.tofly.base.utils;


import cn.hutool.core.util.StrUtil;
import cn.hutool.crypto.SmUtil;
import cn.hutool.crypto.asymmetric.KeyType;
import cn.hutool.crypto.asymmetric.SM2;

/**
 * 理工接口数据加解密方法
 * @author zhoux
 *
 */
public class NetworkCrypt {
	
    // 公钥加密
    public static String encrypt(String data, String publickey) {
        SM2 sm2=SmUtil.sm2(null,publickey);
        String encryptStr = sm2.encryptBcd(data, KeyType.PublicKey);
        return encryptStr;
    }
    

    // 私钥解密 公钥加密密文
 	public static String decrypt(String encryptStr, String privatekey){
         if(!encryptStr.startsWith("04")){
             encryptStr="04".concat(encryptStr);
         }
         SM2 sm2= SmUtil.sm2(privatekey,null);
         String decryptStr = StrUtil.utf8Str(sm2.decryptFromBcd(encryptStr, KeyType.PrivateKey));
         return decryptStr;
     }

}
