package com.tofly.base.utils;

import com.tofly.common.core.util.StringUtil;
import io.jsonwebtoken.Claims;
import io.jsonwebtoken.Jwts;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;

public class UserTokenUtil {

    private static String tokenSigningKey = "1qaz2wsx3edc4rfv5tgb6yhn7ujm1qaz2wsx3edc4rfv5tgb6yhn7ujm1qaz2wsx3edc4rfv5tgb6yhn7ujm1qaz2wsx3edc4rfv5tgb6yhn7ujm";

    private static String getAuthorization() {
        HttpServletRequest request=null;
        try{
             request = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getRequest();

        }catch (Exception e ){
            return  null;
        }

        String token = request.getHeader("authorization");
        if (!StringUtil.isEmpty(token)) {
            if (token.startsWith("Bearer")) {
                token = token.replace("Bearer", "").trim();
            }
            if (token.startsWith("bearer")) {
                token = token.replace("bearer", "").trim();
            }
            return token;
        } else {
            token = request.getHeader("X-Authorization");
            if (!StringUtil.isEmpty(token)) {
                if (token.startsWith("Bearer")) {
                    token = token.replace("Bearer", "").trim();
                }
                if (token.startsWith("bearer")) {
                    token = token.replace("bearer", "").trim();
                }
                return token;
            }
        }
        return null;
    }

    /**
     * 解析token
     */
    public static String getTokenUserID() {
        try {
            String jwt = getAuthorization();
            if (!StringUtil.isEmpty(jwt)) {
                Claims claims = Jwts.parser()
                        .setSigningKey(tokenSigningKey)
                        .parseClaimsJws(jwt)
                        .getBody();
                return claims.get("userId", String.class);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}
