package com.tofly.pms.base.controller;
 
public enum ExceptionEnum {
    /**
     * 请求错误！
     */
    BAD_REQUEST("400", "请求错误！"),
    /**
     * 未经授权的请求！
     */
    UNAUTHORIZED("401", "未经授权的请求！"),
    /**
     * 没有访问权限！
     */
    FORBIDDEN("403", "没有访问权限！"),
    /**
     * 请求的资源未不到！
     */
    NOT_FOUND("404", "请求的资源未不到！"),
    /**
     * 服务器内部错误！
     */
    INTERNAL_SERVER_ERROR("500", "服务器内部错误！"),
    /**
     * 服务器正忙，请稍后再试！
     */
    BAD_GATEWAY("502", "服务器正忙，请稍后再试！"),
    /**
     * 服务器正忙，请稍后再试！
     */
    SERVICE_UNAVAILABLE("503", "服务器正忙，请稍后再试！"),
    /**
     * 网关超时！
     */
    GATEWAY_TIMEOUT("504", "网关超时！"),
    /**
     * 非法参数异常！
     */
    ILLEGAL_ARGUMENT_ERROR("10000", "非法参数异常！"),
    /**
     * 用户ID不能为空！
     */
    USER_ID_NOT_BLANK("10001", "用户ID不能为空！"),
    /**
     *
     */
    UNKNOWN("9999", "未知异常！");
 
    /**
     * 错误码
     */
    private final String code;
 
    /**
     * 错误描述
     */
    private final String errorMsg;
 
    ExceptionEnum(String code, String errorMsg) {
        this.code = code;
        this.errorMsg = errorMsg;
    }
 
    public String getCode() {
        return code;
    }
 
    public String getErrorMsg() {
        return errorMsg;
    }
}