package com.tofly.pms.base.controller;

import cn.hutool.core.exceptions.ValidateException;
import com.tofly.pms.exception.BusinessException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

@RestControllerAdvice(basePackages={"com.tofly.pms"})
@Slf4j
public class GlobalExceptionHandler {

    @ExceptionHandler
    public <T> Result<T> exceptionHandler1(Exception exception) {
        log.error(exception.getMessage(),exception);
        ExceptionEnum exceptionEnum = ExceptionEnum.UNKNOWN;
        if (exception instanceof BusinessException) {
            exceptionEnum = ExceptionEnum.INTERNAL_SERVER_ERROR;
        }
        if (exception instanceof IndexOutOfBoundsException) {
            exceptionEnum = ExceptionEnum.ILLEGAL_ARGUMENT_ERROR;
        }
        if (exception instanceof ValidateException) {
            return Result.fail(ExceptionEnum.ILLEGAL_ARGUMENT_ERROR.getCode(),exception.getMessage());
        }
        if (exception instanceof RuntimeException) {
            return Result.fail(ExceptionEnum.UNKNOWN.getCode(),exception.getMessage());
        }
        return Result.fail(exceptionEnum);
    }
} 