package com.tofly.pms.config;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.tofly.common.core.util.DateUtil;
import com.tofly.pms.utils.UserTokenUtil;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Component;

@Component
@Primary
public class MybatisPlusHandler implements MetaObjectHandler {

    public MybatisPlusHandler() {
    }
    @Override
    public void insertFill(MetaObject metaObject) {
//        ToflyUser toflyUser = ToflySecurityUtils.getUser();
        final String tokenUserID = UserTokenUtil.getTokenUserID();
        this.setFieldValByName("deleted", 0, metaObject);
        this.setFieldValByName("createTime", DateUtil.getCurrentTime(), metaObject);
        this.setFieldValByName("lastTime", DateUtil.getCurrentTime(), metaObject);
        this.setFieldValByName("updateTime", DateUtil.getCurrentTime(), metaObject);
        this.setFieldValByName("changeDate", DateUtil.getCurrentTime(), metaObject);
        this.setFieldValByName("createDate", DateUtil.getCurrentTime(), metaObject);
        this.setFieldValByName("createdate", DateUtil.getCurrentTime(), metaObject);
        if (tokenUserID != null) {
            this.setFieldValByName("createUser", tokenUserID, metaObject);
            this.setFieldValByName("creatorid", tokenUserID, metaObject);
            if (metaObject.hasGetter("userId") && metaObject.getValue("userId") == null) {
                this.setFieldValByName("userId", tokenUserID, metaObject);
            }

            this.setFieldValByName("updateUser", tokenUserID, metaObject);
            this.setFieldValByName("changeUser", tokenUserID, metaObject);
        }

    }

    @Override
    public void updateFill(MetaObject metaObject) {
        final String tokenUserID = UserTokenUtil.getTokenUserID();
        if(tokenUserID!=null){
            this.setFieldValByName("updateUser", tokenUserID, metaObject);
            this.setFieldValByName("changeUser", tokenUserID, metaObject);
        }
        this.setFieldValByName("updateTime", DateUtil.getCurrentTime(), metaObject);
        this.setFieldValByName("lastTime", DateUtil.getCurrentTime(), metaObject);
        this.setFieldValByName("changeDate", DateUtil.getCurrentTime(), metaObject);

    }
}
