package com.tofly.pms.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 实体基类
 */
@Getter
@Setter
public class BaseEntity extends BaseEntityAdaptiveIsDelete {

    /**
     * 创建用户
     */
//    @DisplayText(converter = UserConverter.class)
    private String creator;
    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;
    /**
     * 更新用户
     */
//    @DisplayText(converter = UserConverter.class)
    private String updater;
    /**
     * 更新时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    /**
     * 页数
     */
    @TableField(exist = false)
    private Integer page = 1;

    /**
     * 每页条数
     */
    @TableField(exist = false)
    private Integer pageSize = 20;

    /**
     * 关键字
     */
    @TableField(exist = false)
    private String keyword;

    /**
     * 排序字段
     */
    @TableField(exist = false)
    private String sort;

    /**
     * 排序顺序
     */
    @TableField(exist = false)
    private String sortDirections;
}
