package com.tofly.pms.fegin;

import com.tofly.pms.fegin.factory.UserClientFactory;
import com.tofly.pms.fegin.vo.UserVo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(contextId = "baseUserService",value = "pms-base",fallbackFactory = UserClientFactory.class )
public interface UserClient {


    @PostMapping("/api/yt/user/info")
    public UserVo getUserInfo(@RequestParam("id") String id);
    @PostMapping("/api/yt/user/infos")
    public List<UserVo> getUserIdByName(@RequestParam("username")String username);
    @PostMapping("/api/yt/user/getUserIdByRealName")
    List<UserVo> getUserIdByRealName(@RequestBody List<String> nameList);
}
