package com.tofly.pms.file.controller;

import com.tofly.pms.entity.dto.FileUploadResponse;
import com.tofly.pms.file.entity.File;
import com.tofly.pms.file.service.FileService;
import com.tofly.pms.utils.MinioUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;

@Api(tags = "通用文件接口")
@RestController
@RequestMapping("/commonFile")
@AllArgsConstructor
public class CommonFileController {
@Autowired
private MinioUtils minioUtils;
@Autowired
private FileService fileService;

    @PostMapping("upload")
    @ApiOperation("文件上传接口")
    public ResponseEntity<FileUploadResponse> uploadFile(@RequestPart("file") MultipartFile file){
        final FileUploadResponse upload = minioUtils.upload(file);
        return  ResponseEntity.ok(upload);
    }

    @PostMapping("uploadMulti")
    @ApiOperation("文件上传接口(多文件)")
    public ResponseEntity<List<FileUploadResponse>> uploadFile(@RequestPart("files") MultipartFile[] files){
        List<FileUploadResponse> resultList = new ArrayList<>();
        for (MultipartFile file : files) {
            final FileUploadResponse upload = minioUtils.upload(file);
            resultList.add(upload);
        }










































































































































































































































































































        return  ResponseEntity.ok(resultList);
    }
    @SneakyThrows(Exception.class)
    @GetMapping("{fileNameOrId}")
    @ApiOperation("文件预览接口")
    public void download(@PathVariable("fileNameOrId") String fileNameOrId, HttpServletResponse response){
        try{
            final File byId = fileService.getById(Integer.valueOf(fileNameOrId));
            if(byId!=null){
                fileNameOrId = byId.getOtherName();
            }
        }catch (Exception e){

        }
        minioUtils.download(fileNameOrId,response);
    }



    @SneakyThrows(Exception.class)
    @GetMapping("getUploadObjectUrl")
    @ApiOperation("获取文件外链")
    public ResponseEntity<String> getUploadObjectUrl( String fileName, HttpServletResponse response){
        final String uploadObjectUrl = minioUtils.getUploadObjectUrl(fileName, 600);
        return ResponseEntity.ok(uploadObjectUrl);
    }
}
