/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.pms.file.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 公共文件表： TF_YWPN_FILE_W
 *
 * @author admin
 * @date Wed Mar 10 00:00:00 CST 2021
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "tf_pm_file",schema = "business")
@KeySequence("tf_pm_file")
@ApiModel
public class File extends Model<File> {
    private static final long serialVersionUID = 1L;

    /**
     * 唯一编码
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "唯一编码")
    private Integer id;
    /**
     * 关联表名字
     */
    @ApiModelProperty(value = "关联表名字")
    private String tableName;
    /**
     * 关联表名对应关键字ID
     */
    @ApiModelProperty(value = "关联表名对应关键字ID")
    private String tableId;
    /**
     * 文件路径
     */
    @ApiModelProperty(value = "文件路径")
    private String filePath;
    /**
     * 有效标志；0：正常；1：删除
     */
    @ApiModelProperty(value = "有效标志；0：正常；1：删除")
    private String statusFlag;
    /**
     * 文件原名称
     */
    @ApiModelProperty(value = "文件原名称")
    private String fileName;
    /**
     * 文件上传后名称
     */
    @ApiModelProperty(value = "文件上传后名称")
    private String otherName;
    /**
     * 文件后缀
     */
    @ApiModelProperty(value = "文件后缀")
    private String fileFormat;
    /**
     * 文件大小
     */
    @ApiModelProperty(value = "文件大小")
    private String fileSize;
    /**
     * 文件类型：0为一般附件，1为反应谱特征周期附件
     */
    private String fileType;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(value = "CREATED_TIME", fill = FieldFill.INSERT)
    private Date createTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    @TableField(value = "create_user", fill = FieldFill.INSERT)
    private String createUser;


}
