package com.tofly.pms.glossary.constants;

/**
 * @ClassName: Constant
 * @Description: 常量
 * @Author Zev
 * @Date 2021/3/18
 * @Version 1.0.0
 */
public class Constant {

    /**
     * 导入导出文件相关
     */
    public static String DEFAULT_REPORT_IMPORT_FOLDER = "/report/import";
    public static String DEFAULT_REPORT_EXPORT_FOLDER = "/report/export";

    /**
     * 系统分隔符
     */
    public static String SYSTEM_SEPARATOR = "/";

    /**
     * 获取项目根目录
     */
    public static String PROJECT_ROOT_DIRECTORY = System.getProperty("user.dir").replaceAll("\\\\", SYSTEM_SEPARATOR);

    /**
     * excel导出测试临时存储路径
     */
    public static String FILE_PATH_TEST_EXPORT_EXCEL = PROJECT_ROOT_DIRECTORY + "/excel.xls";

    public static String MONTH = "1";

    public static String YEAR = "0";

    public static String POINT = ".";

    public static String KB = "kb";
    public static final String NEW_FAIL = "新增失败";
    public static final Integer NEW_FAIL_CODE = 40002;
    public static final String QUERY_FAIL = "查询失败";
    public static final String DATA_NONENTITY = "数据不存在";
    public static final Integer DATA_NONENTITY_CODE = 40003;
    public static final String UPDATE_FAIL = "更新失败";
    public static final Integer UPDATE_FAIL_CODE = 40004;
    public static final String DELETE_FAIL = "删除失败";
    public static final Integer DELETE_FAIL_CODE = 40005;



    public static final String DELETE_FAIL_NULL = "删除失败，参数不能为空！";
    public static final Integer DELETE_FAIL_CODE_NULL = 400051;
    public static final String DATA_VALIDATION = "数据校验失败,请检查传入参数";
    public static final Integer DATA_VALIDATION_CODE = 40006;
    public static final String CSV = ",";

    public static final Integer ID_CODE = 40007;
    public static final String ID_INFO = "ID不能为空";

    public static final Integer DZDZ_ID_CODE = 40008;
    public static final String DZDZ_ID_INFO = "地灾地形ID不能为空";

    public static final String DZDZ_DZLX_INFO = "地灾类型不能为空";

    public static final String NULL_CODE_INFO = "数据不存在";
    public static final Integer NULL_CODE = 50001;

    public static final String SAVE_NULL_INFO = "保存数据不能为空";
    public static final Integer SAVE_NULL_INFO_CODE = 50002;

    public static final String ARGUMENT_NULL="参数错误，请检查参数！";
    public static final Integer ARGUMENT_NULL_CODE=50003;

    public static final String TOKEN_NULL="Token超时。请重新登录！";
    public static final Integer TOKEN_NULL_CODE=50004;


    public static final String XCINFO_CG="已存在草稿，不能再次提交草稿！";
    public static final Integer XCINFO_CG_CODE=60001;

    public static final String FILE_UPLOAD_ERROR = "当前新增对象中,文件上传失败,请重试";
    public static final Integer FILE_UPLOAD_ERROR_CODE = 60036;

    public static final String GC_NULL_BASEINFO="工程基础信息不能为空！";

    public static final String GC_NULL_FAINFO="工程方案信息不能为空！";
    public static final String GC_NULL_SJJDINFO="工程阶段信息不能为空！";
    public static final String GC_NULL_GCBW="工程部位信息不能为空！";
    public static final Integer GC_NULL_CODE=70001;


}
