package com.tofly.pms.project.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.tofly.pms.project.service.ProjectWService;
import com.tofly.pms.utils.vocast.VoCast;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

 /**
 * 项目成果信息表;
 * @author : Xu'J
 * @date : 2023-12-19
 */
@ApiModel(value = "项目成果信息表",description = "")
@TableName(value = "TF_PM_PROJECTRES_W",schema = "business")
@Data
public class ProjecTresW implements Serializable,Cloneable{
    /** 唯一编码 */
    @ApiModelProperty(value = "唯一编码",name = "id")
    @TableId(type = IdType.AUTO)
    private Integer id ;
    /** 项目id */
    @ApiModelProperty(value = "项目id",name = "projectId")
    @VoCast(serviceClass = ProjectWService.class,valueClass = ProjectW.class)
    private Integer projectId ;
    /** 成果名称 */
    @ApiModelProperty(value = "成果名称",name = "name")
    private String name ;
    /** 演示视频;视频存储信息 */
    @ApiModelProperty(value = "演示视频",name = "showVideoUrl")
    private String showVideoUrl ;


}