package com.tofly.pms.project.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.tofly.pms.fegin.UserClient;
import com.tofly.pms.fegin.vo.UserVo;
import com.tofly.pms.project.service.ProjectWService;
import com.tofly.pms.utils.dict.Dict;
import com.tofly.pms.utils.vocast.VoCast;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

 /**
 * 项目研发信息表;
 * @author : Xu'J
 * @date : 2023-12-19
 */
@ApiModel(value = "项目研发信息表",description = "")
@TableName(value = "TF_PM_PROJECTDEV_W",schema = "business")
@Data
public class ProjectdevW implements Serializable,Cloneable{
    /** id */
    @ApiModelProperty(value = "id",name = "id")
    @TableId(type = IdType.AUTO)
    private Integer id ;
    /** 项目id */
    @ApiModelProperty(value = "项目id",name = "projectId")
    @VoCast(serviceClass = ProjectWService.class,valueClass = ProjectW.class)
    private Integer projectId ;
    /** 系统名称 */
    @ApiModelProperty(value = "系统名称",name = "name")
    private String name ;
     /** 系统名称 */
     @ApiModelProperty(value = "环境类型 字典编码 HJLX",name = "environmentType")
     @Dict(code = "HJLX")
     private String environmentType ;
     /** 系统名称 */
     @ApiModelProperty(value = "服务器类型 字典编码 FWQLX",name = "serverType")
     @Dict(code = "FWQLX")
     private String serverType ;
    /** 访问地址 */
    @ApiModelProperty(value = "访问地址",name = "visitAddress")
    private String visitAddress ;
    /** APP二维码;二维码图片存放信息 */
    @ApiModelProperty(value = "APP二维码",name = "appQrcode")
    private String appQrcode ;
    /** 用户名 */
    @ApiModelProperty(value = "用户名",name = "loginUser")
    private String loginUser ;
    /** 密码 */
    @ApiModelProperty(value = "密码",name = "loginPassword")
    private String loginPassword ;
    /** 系统负责人ID */
    @ApiModelProperty(value = "系统负责人ID",name = "headId")
    @VoCast(serviceClass = UserClient.class,isMulti =true,valueClass = UserVo.class)
    private String headId ;
    /** 最近发布日期 */
    @ApiModelProperty(value = "最近发布日期",name = "currentPublishDate")
    @TableField(fill = FieldFill.INSERT)
    private Date currentPublishDate ;
    /** 系统说明;系统简介、包含的主要功能模块 */
    @ApiModelProperty(value = "系统说明",name = "description")
    private String description ;
    /** 技术说明;系统技术栈说明 */
    @ApiModelProperty(value = "技术说明",name = "techDescription")
    private String techDescription ;
    /** 环境配置;技术相关环境配置说明 */
    @ApiModelProperty(value = "环境配置",name = "environmentConfig")
    private String environmentConfig ;
    /** 备注 */
    @ApiModelProperty(value = "备注",name = "note")
    private String note ;
    /** 标签;中文逗号分隔 */
    @ApiModelProperty(value = "标签",name = "label")
    private String label ;
    /** 是否对外开放 */
    @ApiModelProperty(value = "是否对外开放",name = "isOpen")
    private String isOpen ;
    /** 是否正式环境 */
    @ApiModelProperty(value = "是否正式环境",name = "isRegular")
    private String isRegular ;
    /** 是否支持外网访问 */
    @ApiModelProperty(value = "是否支持外网访问",name = "isSupportExternalVisit")
    private String isSupportExternalVisit ;
     @ApiModelProperty(value = "代码地址",name = "codeUrl")
     private String codeUrl ;
     @ApiModelProperty(value = "原型地址",name = "prototypeUrl")
     private String prototypeUrl ;
     @ApiModelProperty(value = "UI地址",name = "uiUrl")
     private String uiUrl ;

}