package com.tofly.pms.testmanage.entity;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.HeadStyle;
import com.alibaba.excel.enums.poi.FillPatternTypeEnum;
import lombok.Data;

/**
 * @author sheldon
 * @Description
 * @create 2024-04-07 10:29
 */
@Data
public class SystemItemExcelModel {
    @HeadStyle(fillPatternType = FillPatternTypeEnum.SOLID_FOREGROUND, fillForegroundColor = 14)
    @ExcelProperty(value = "序号", index = 0)
    private String number;
    @HeadStyle(fillPatternType = FillPatternTypeEnum.SOLID_FOREGROUND, fillForegroundColor = 14)
    @ExcelProperty(value = "功能名称", index = 1)
    private String name;
    @ExcelProperty(value = "测试要求", index = 2)
    private String demand;
    @ExcelProperty(value = "是否提测", index = 3)
    private String isCommitTest;
    @ExcelProperty(value = "是否开始测试", index = 4)
    private String isStartTest;
    @ExcelProperty(value = "编号(系统维护)", index = 5)
    private Integer id;
    @ExcelProperty(value = "父级功能(系统维护)", index = 6)
    private String parentName;
    @ExcelProperty(value = "bug总数", index = 7)
    private Integer bugCount;
    @ExcelProperty(value = "bug完成数", index = 8)
    private Integer completeCount;
    @ExcelProperty(value = "冒烟总数", index = 9)
    private Integer count0;
    @ExcelProperty(value = "冒烟完成数", index = 10)
    private Integer completeCount0;
    @ExcelProperty(value = "功能总数", index = 11)
    private Integer count1;
    @ExcelProperty(value = "功能完成数", index = 12)
    private Integer completeCount1;
    @ExcelProperty(value = "界面总数", index = 13)
    private Integer count2;
    @ExcelProperty(value = "界面完成数", index = 14)
    private Integer completeCount2;
    @ExcelProperty(value = "流程总数", index = 15)
    private Integer count3;
    @ExcelProperty(value = "流程完成数", index = 16)
    private Integer completeCount3;
    @ExcelProperty(value = "其他总数", index = 17)
    private Integer count5;
    @ExcelProperty(value = "其他完成数", index = 18)
    private Integer completeCount5;


    public SystemItem toSystemItem() {
        SystemItem systemItem = new SystemItem();
        systemItem.setId(this.id);
        systemItem.setName(this.name);
        systemItem.setDemand(this.demand);
        if ("是".equals(this.isCommitTest)) {
            systemItem.setIsCommitTest("true");
        } else {
            systemItem.setIsCommitTest("false");
        }
        if ("是".equals(this.isStartTest)) {
            systemItem.setIsStartTest("true");
        } else {
            systemItem.setIsStartTest("false");
        }
        systemItem.setNumber(this.number);
        systemItem.setLevel(this.number.split("\\.").length);
        return systemItem;
    }
}
