package com.tofly.pms.testmanage.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.tofly.pms.project.entity.ProjectW;
import com.tofly.pms.project.service.ProjectWService;
import com.tofly.pms.utils.vocast.VoCast;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

 /**
 * 测试系统名称表;
 * @author : Xu'J
 * @date : 2023-12-19
 */
@ApiModel(value = "测试系统名称表",description = "")
@TableName(value = "TF_PM_TESTSYSTEM_W",schema = "business")
@Data
public class TestSystem implements Serializable,Cloneable{
    /** id */
    @ApiModelProperty(value = "id",name = "id")
    @TableId(type = IdType.AUTO)
    private Integer id ;
    /** 项目id */
    @ApiModelProperty(value = "项目id",name = "projectId")
    @VoCast(serviceClass = ProjectWService.class,valueClass = ProjectW.class)
    private Integer projectId ;
    /** 项目名称 */
    @ApiModelProperty(value = "项目名称",name = "projectName")
    private String projectName ;
    /** 系统唯一编码 */
    @ApiModelProperty(value = "系统唯一编码",name = "code")
    private String code ;
    /** 系统名称 */
    @ApiModelProperty(value = "系统名称",name = "name")
    private String name ;
    /** 系统代码 */
    @ApiModelProperty(value = "系统代码",name = "systemCode")
    private String systemCode ;

}