package com.tofly.pms.testmanage.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.tofly.pms.testmanage.entity.BugInfo;
import com.tofly.pms.testmanage.entity.BugInfoExcelModel;
import com.tofly.pms.testmanage.entity.StatisticsBug;
import com.tofly.pms.testmanage.vo.BugStatusCountOverProjectVo;
import com.tofly.pms.testmanage.vo.BugStatusCountVo;
import com.tofly.pms.testmanage.vo.ToResolveOverTypeVo;
import com.tofly.pms.testmanage.vo.ToSureLeftVo;
import com.tofly.pms.working.vo.TestTypeCountVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDateTime;
import java.util.List;

/**
 * 测试BUG表;(TF_PM_BUG_W)表数据库访问层
 *
 * @author : Xu'J
 * @date : 2023-12-19
 */
@Mapper
public interface BugInfoMapper extends BaseMapper<BugInfo> {
    /**
     * 分页查询指定行数据
     *
     * @param page    分页参数
     * @param wrapper 动态查询条件
     * @return 分页对象列表
     */
    IPage<BugInfo> selectByPage(IPage<BugInfo> page, @Param(Constants.WRAPPER) Wrapper<BugInfo> wrapper);

    public List<BugStatusCountVo> bugStatusOverCount(@Param("bugInfo") BugInfo bugInfo,@Param("selfProjectId") List<Integer> selfProjectId);


    List<ToResolveOverTypeVo> gettoResolveCount(@Param("bugInfo") BugInfo bugInfo);

    public List<BugStatusCountOverProjectVo> BugStatusCountOverProject(@Param("bugInfo") BugInfo bugInfo);


    public List<ToSureLeftVo> toSureLeft(List<Integer> projectIds, String userId);

    List<TestTypeCountVo> getTestTypeCount(@Param("functionId") Integer functionId);

    List<StatisticsBug> getStatisticalEnsemble(@Param("projectId") Integer projectId,
                                               @Param("startTime") LocalDateTime startTime,
                                               @Param("endTime") LocalDateTime endTime,
                                               @Param("startHandleTime") LocalDateTime startHandleTime,
                                               @Param("endHandleTime") LocalDateTime endHandleTime,
                                               @Param("startVerifyTime") LocalDateTime startVerifyTime,
                                               @Param("endVerifyTime") LocalDateTime endVerifyTime);
    List<StatisticsBug> getStatisticalBySystem(@Param("projectId") Integer projectId,
                                               @Param("startTime") LocalDateTime startTime,
                                               @Param("endTime") LocalDateTime endTime,
                                               @Param("fix")Integer fix,
                                               @Param("startHandleTime") LocalDateTime startHandleTime,
                                               @Param("endHandleTime") LocalDateTime endHandleTime,
                                               @Param("startVerifyTime") LocalDateTime startVerifyTime,
                                               @Param("endVerifyTime") LocalDateTime endVerifyTime);

    List<StatisticsBug> getStatisticalByHead(@Param("projectId") Integer projectId,
                                             @Param("startTime") LocalDateTime startTime,
                                             @Param("endTime") LocalDateTime endTime,
                                             @Param("fix")Integer fix,
                                             @Param("startHandleTime") LocalDateTime startHandleTime,
                                             @Param("endHandleTime") LocalDateTime endHandleTime,
                                             @Param("startVerifyTime") LocalDateTime startVerifyTime,
                                             @Param("endVerifyTime") LocalDateTime endVerifyTime);

    List<StatisticsBug> getStatisticalBySure(@Param("projectId") Integer projectId,
                                             @Param("startTime") LocalDateTime startTime,
                                             @Param("endTime") LocalDateTime endTime,
                                             @Param("fix")Integer fix,
                                             @Param("startHandleTime") LocalDateTime startHandleTime,
                                             @Param("endHandleTime") LocalDateTime endHandleTime,
                                             @Param("startVerifyTime") LocalDateTime startVerifyTime,
                                             @Param("endVerifyTime") LocalDateTime endVerifyTime);

    List<BugInfoExcelModel> getExportData(@Param("projectId")Integer projectId,
                                          @Param("systemId")Integer systemId,
                                          @Param("headId")String headId,
                                          @Param("createUser")String createUser);
}