package com.tofly.pms.testmanage.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.tofly.pms.testmanage.entity.BugLog;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * BUG处理日志表;(TF_PM_BUGLOG_W)表数据库访问层
 *
 * @author : Xu'J
 * @date : 2023-12-19
 */
@Mapper
public interface BugLogWMapper extends BaseMapper<BugLog> {
    /**
     * 分页查询指定行数据
     *
     * @param page    分页参数
     * @param wrapper 动态查询条件
     * @return 分页对象列表
     */
    IPage<BugLog> selectByPage(IPage<BugLog> page, @Param(Constants.WRAPPER) Wrapper<BugLog> wrapper);

    List<Integer> getBugIdList(@Param("type") int type, @Param("userId") String userId);
}