package com.tofly.pms.testmanage.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.tofly.pms.testmanage.entity.SystemItem;
import com.tofly.pms.testmanage.vo.ItemPassCountVo;
import com.tofly.pms.testmanage.vo.ItemStatusVo;
import com.tofly.pms.testmanage.vo.SystemCommitContVo;
import com.tofly.pms.testmanage.vo.SystemPassCountVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 测试系统功能清单表;(TF_PM_TESTSYSTEMITEM_W)表数据库访问层
 * @author : Xu'J
 * @date : 2023-12-19
 */
@Mapper
public interface SystemItemWMapper  extends BaseMapper<SystemItem>{
    /** 
     * 分页查询指定行数据
     *
     * @param page 分页参数
     * @param wrapper 动态查询条件
     * @return 分页对象列表
     */
    IPage<SystemItem> selectByPage(IPage<SystemItem> page , @Param(Constants.WRAPPER) Wrapper<SystemItem> wrapper);


    List<ItemPassCountVo> itemThrowCount(@Param("itemIds")List<Integer> itemIds);

    List<SystemPassCountVo> systemPassCount(@Param("projectId")Integer projectId);

    List<SystemCommitContVo> sytemCommitRate(@Param("projectId")Integer projectId);

    List<ItemStatusVo> itemStatusCount(@Param("projectId")Integer projectId);


}