package com.tofly.pms.testmanage.service;

import com.tofly.pms.base.service.BaseService;
import com.tofly.pms.testmanage.entity.BugInfo;
import com.tofly.pms.testmanage.entity.StatisticsBug;
import com.tofly.pms.testmanage.vo.BugStatusCountProjectVo;
import com.tofly.pms.testmanage.vo.BugStatusCountVo;
import com.tofly.pms.testmanage.vo.ToResolveCountVo;
import com.tofly.pms.testmanage.vo.ToSureLeftVo;
import com.tofly.pms.working.vo.TestTypeCountVo;
import org.springframework.web.bind.annotation.RequestParam;

import java.io.IOException;
import java.util.List;

/**
 * 测试BUG表;(TF_PM_BUG_W)表服务接口
 *
 * @author : Xu'J
 * @date : 2023-12-19
 */
public interface BugInfoService extends BaseService<BugInfo> {
    List<BugStatusCountVo> bugStatusOverCount(BugInfo bugInfo);

    ToResolveCountVo gettoResolveCount(BugInfo bugInfo);

    List<BugStatusCountProjectVo> BugStatusCountOverProject(BugInfo bugInfo);


    List<ToSureLeftVo> toSureCountLeft(String userId);

    /**
     * 保存保存或修改并生成bug操作日志
     *
     * @param bugInfo
     */
    void saveOrUpdateWithLog(BugInfo bugInfo);

    /**
     * 批量保存或修改 并生成bug操作日志
     *
     * @param bugInfos
     */
    void saveOrUpdateBatchWithLog(List<BugInfo> bugInfos);

    List<TestTypeCountVo> getTestTypeCount(Integer functionId);

    List<StatisticsBug> getStatisticalEnsemble(Integer projectId, String startSearchTime, String endSearchTime,
                                               String startHandleTime,
                                               String endHandleTime,
                                               String startVerifyTime,
                                               String endVerifyTime);

    List<StatisticsBug> getStatisticalBySystem(Integer projectId, String startSearchTime, String endSearchTime, Integer fix,
                                               String startHandleTime,
                                               String endHandleTime,
                                               String startVerifyTime,
                                               String endVerifyTime);

    List<StatisticsBug> getStatisticalByHead(Integer projectId, String startSearchTime, String endSearchTime, Integer fix,
                                             String startHandleTime,
                                             String endHandleTime,
                                             String startVerifyTime,
                                             String endVerifyTime);

    List<StatisticsBug> getStatisticalBySure(Integer projectId, String startSearchTime, String endSearchTime, Integer fix,
                                             String startHandleTime,
                                             String endHandleTime,
                                             String startVerifyTime,
                                             String endVerifyTime);

    void updateBugInfo(BugInfo bugInfo);

    void export(Integer projectId, Integer systemId, String headId, String createUser) throws IOException;
}