package com.tofly.pms.testmanage.service.impl;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.pms.testmanage.entity.BugLog;
import com.tofly.pms.testmanage.mapper.BugLogWMapper;
import com.tofly.pms.testmanage.service.BugLogService;
import com.tofly.pms.utils.UserTokenUtil;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * BUG处理日志表;(TF_PM_BUGLOG_W)表服务实现类
 *
 * @author : Xu'J
 * @date : 2023-12-19
 */
@Service
public class BugLogServiceImpl extends ServiceImpl<BugLogWMapper, BugLog> implements BugLogService {

    @Override
    public BugLog queryById(Integer id) {
        return baseMapper.selectById(id);
    }

    @Override
    public boolean save(BugLog entity) {
        Assert.notNull(entity, "保存对象不能为空");
        Assert.notNull(entity.getBugId(), "缺陷id不能为空");
        Assert.notBlank(entity.getStatus(), "处理状态不能为空");
        Assert.notBlank(entity.getJsonData(),"bug不能为空");
        entity.setHandleUser(UserTokenUtil.getTokenUserID());
        entity.setHandleTime(new Date());
        return super.save(entity);
    }

    @Override
    public boolean updateById(BugLog entity) {
        throw new RuntimeException("日志记录不允许修改");
    }

    @Override
    public boolean removeById(Serializable id) {
        throw new RuntimeException("日志记录不允许删除");
    }

    @Override
    public List<Integer> getBugIdList(int type) {
        String userId = UserTokenUtil.getTokenUserID();
        return baseMapper.getBugIdList(type,userId) ;
    }
}