package com.tofly.pms.utils;

import com.tofly.pms.entity.dto.FileUploadResponse;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import java.util.Objects;

public class RichTextUtil {
    /**
     *
     * @param text 富文本内容
     * @return  返回处理图片后的数据
     */
    public String richText(String text,MinioUtils minioUtils){
        String s = new String(text);
        String result = null;//返回结果
        List<String> imgStr = ImgBaseUtil.getImgStr(s); //每组base64编码图片
        if (imgStr.isEmpty()){
            return text;
        }
        for (String s1 : imgStr){ //每个base64转换并上传
            //上传
            MultipartFile multipartFile = BASE64DecodedMultipartFile.base64ToMultipart(s1);

            FileUploadResponse upload = minioUtils.upload(multipartFile);

            String foreverUrl = upload.getFileStaticUri();//永久链接

            if (Objects.isNull(result)){
                result = s.replace(s1,foreverUrl); //第一次替换
            }
            result=result.replace(s1,foreverUrl); //前边替换过，继续替换

        }
        return result;
    }
}