package com.tofly.pms.utils;

import cn.hutool.extra.spring.SpringUtil;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.tofly.pms.fegin.UserClient;
import com.tofly.pms.fegin.vo.UserVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

@Component
public class UserUtils {
    @Autowired
    RedisTemplate redisTemplate;
    public UserVo  getUserVoByUserId(String userId) {
        final String userInfoStr = (String) redisTemplate.opsForHash().get("pms:userInfo", userId);
        UserVo userInfo;
        if (StringUtils.isNotBlank(userInfoStr)) {
            userInfo = JSON.parseObject(userInfoStr, UserVo.class);
        } else {
            UserClient userClient = (UserClient) SpringUtil.getBean(UserClient.class);
            try {
                userInfo = userClient.getUserInfo(userId);
            } catch (Exception e) {
                userInfo = null;
            }

            //redisTemplate.opsForValue().set(userId,JSON.toJSONString(userInfo));
            redisTemplate.opsForHash().put("pms:userInfo", userId, JSON.toJSONString(userInfo));
        }

        return userInfo;


    }

    /**
     * 通过 用户真实名称或者 登录名查找用户信息
     * @param name
     * @return
     */
    public UserVo  getUserVoByUserName(String name){

        return  null;

    }

}
