package com.tofly.pms.utils.dict;

import com.fasterxml.jackson.databind.AnnotationIntrospector;
import com.tofly.pms.utils.vocast.VoCastSensitiveAnnotationIntrospector;
import org.springframework.boot.autoconfigure.jackson.Jackson2ObjectMapperBuilderCustomizer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;

/**
 * 修改被@Dict注解标注的属性字典序列化方式
 * @author liujing
 */
@Configuration
public class DictSerializerConfig {

    @Resource
    private DictSensitiveAnnotationIntrospector dictSensitiveAnnotationIntrospector;
    @Resource
    private VoCastSensitiveAnnotationIntrospector voCastSensitiveAnnotationIntrospector;
//    @Resource
//    private ToflyFileAnnotationIntrospector fileAnnotationIntrospector;


    @Bean
    public Jackson2ObjectMapperBuilderCustomizer jackson2ObjectMapperBuilderCustomizer() {
         AnnotationIntrospector pair =
                 AnnotationIntrospector.pair(voCastSensitiveAnnotationIntrospector,dictSensitiveAnnotationIntrospector);
       // final AnnotationIntrospector pair1 = AnnotationIntrospector.pair(pair, fileAnnotationIntrospector);
        return builder -> builder.annotationIntrospector(pair) ;
    }
}