package com.tofly.pms.utils.easyListener.converter;

import cn.hutool.extra.spring.SpringUtil;
import com.alibaba.excel.converters.Converter;
import com.alibaba.excel.converters.ReadConverterContext;
import com.alibaba.excel.enums.CellDataTypeEnum;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.tofly.pms.fegin.UserClient;
import com.tofly.pms.fegin.vo.UserVo;

import java.util.List;

public class CustomStringToUserIdsConverter implements Converter<String> {


    @Override
    public Class<?> supportJavaTypeKey() {
        return String.class;
    }

    @Override
    public CellDataTypeEnum supportExcelTypeKey() {
        return CellDataTypeEnum.STRING;
    }

    /**
     * 这里读的时候会调用
     *
     * @param context
     * @return
     */
    @Override
    public String convertToJavaData(ReadConverterContext<?> context) {
        StringBuffer ids = new StringBuffer();
        final UserClient bean = SpringUtil.getBean(UserClient.class);
        final String userNames = context.getReadCellData().getStringValue();
        if(StringUtils.isNotBlank(userNames)){

            final String[] userNameArr = userNames.split(",");
            //通过name查找 id

            for (String s : userNameArr) {
                final List<UserVo> userIdByName = bean.getUserIdByName(s);
                if(userIdByName.size()>1){
                    //用户名有相同的
                }else{
                    if(userIdByName.size()==0){
                        final String id = userIdByName.get(0).getId();
                      ids.append(id).append(",");
                    }
                }
            }


        }


        return ids.toString();
    }


}