package com.tofly.pms.utils.easyListener.converter;

import cn.hutool.extra.spring.SpringUtil;
import com.alibaba.excel.converters.Converter;
import com.alibaba.excel.converters.ReadConverterContext;
import com.alibaba.excel.metadata.property.ExcelContentProperty;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.tofly.pms.fegin.DictItemClient;
import com.tofly.pms.utils.dict.Dict;
import com.tofly.pms.utils.dict.vo.DictItemVo;

import java.lang.reflect.Field;

public class Todict implements Converter<String> {
    @Override
    public String convertToJavaData(ReadConverterContext<?> context) {
        final DictItemClient bean = SpringUtil.getBean(DictItemClient.class);
        final String data = context.getReadCellData().getStringValue();
        if(StringUtils.isNotBlank(data)){
            //通过name查找 id
            final ExcelContentProperty contentProperty = context.getContentProperty();
            final Field field = contentProperty.getField();
            final Dict annotation = field.getAnnotation(Dict.class);
            final String code = annotation.code();
            final Object itemInfoByName = bean.getItemInfoByName(code, data);
            DictItemVo dictItemVo = JSON.parseObject(JSON.toJSONString(itemInfoByName),DictItemVo.class);
            return  dictItemVo.getId();
        }

        return  String.valueOf(0);
    }
}
