package com.tofly.pms.utils.vocast;

import com.fasterxml.jackson.databind.introspect.Annotated;
import com.fasterxml.jackson.databind.introspect.NopAnnotationIntrospector;
import org.springframework.stereotype.Component;

/**
 * 实体注解序列化拦截器
 */
@Component
public class VoCastSensitiveAnnotationIntrospector extends NopAnnotationIntrospector {

    private static final long serialVersionUID = 1L;

    @Override
    public Object findSerializer(Annotated am) {
        VoCast dict = am.getAnnotation(VoCast.class);
        if (dict != null){
            return VoCastSerializer.class;
        }
        return null;
    }
}