package com.tofly.pms.working.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.tofly.pms.working.entity.Editorlog;
import com.tofly.pms.working.service.EditorlogService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(tags = "编辑日志查询")
@RestController
@RequestMapping("/editorlog")
public class EditorlogController {

    @Autowired
    private EditorlogService editorlogService;

    @ApiOperation("查询")
    @GetMapping("/getByDataIdAndType")
    public ResponseEntity<List<Editorlog>> getByDataIdAndType(@RequestParam("dataId") Integer dataId, @RequestParam("dataType") String dataType) {
        List<Editorlog> list = editorlogService.list(Wrappers.lambdaQuery(Editorlog.class)
                .eq(Editorlog::getDataId, dataId)
                .eq(Editorlog::getDataType, dataType)
                .orderByAsc(Editorlog::getCreateTime));
        return ResponseEntity.ok(list);
    }

}
