package com.tofly.pms.working.controller;

import com.tofly.pms.working.entity.Plan;
import com.tofly.pms.working.service.PerformanceAppraisalService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @author sheldon
 * @Description
 * @create 2024-06-26 14:04
 */
@Api(tags = "工时登记表对象功能接口")
@RestController
@RequestMapping("/performanceAppraisal")
public class PerformanceAppraisalController {
    @Resource
    private PerformanceAppraisalService service;

    @ApiOperation("生成月份绩效")
    @GetMapping("/month")
    public ResponseEntity<Boolean> queryById(@RequestParam(required = false) String month) {
        return ResponseEntity.ok(service.automaticStatistics(month));
    }
}
