package com.tofly.pms.working.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Date;

/**
 * 任务和缺陷编辑记录
 *
 * @TableName tf_pm_editorlog_w
 */
@ApiModel(value = "任务和缺陷编辑记录", description = "任务和缺陷编辑记录")
@TableName(value = "tf_pm_editorlog_w", schema = "business")
@Data
public class Editorlog implements Serializable {

    /**
     * id
     */
    @ApiModelProperty("id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     * 创建时间
     */
    @NotNull(message = "[创建时间]不能为空")
    @ApiModelProperty("创建时间")
    private Date createTime;
    /**
     * 任务(task)、缺陷(bug)
     */
    @NotBlank(message = "[任务(task)、缺陷(bug)]不能为空")
    @ApiModelProperty("任务(task)、缺陷(bug)")
    private String dataType;
    /**
     * 原始数据
     */
    @NotBlank(message = "[原始数据]不能为空")
    @ApiModelProperty("原始数据")
    private String source;
    /**
     * 变更后的数据
     */
    @NotBlank(message = "[变更后的数据]不能为空")
    @ApiModelProperty("变更后的数据")
    private String changedData;
    /**
     * 原来的负责人
     */
    @ApiModelProperty("原来的负责人")
    private String sourceHeadId;
    /**
     * 变更后的负责人
     */

    @ApiModelProperty("变更后的负责人")
    private String changedHeadId;
    /**
     * 原始确认人
     */

    @ApiModelProperty("原始确认人")
    private String sourceSureId;
    /**
     * 变更后的确认人
     */

    @ApiModelProperty("变更后的确认人")
    private String changedSureId;
    /**
     * 其他描述内容
     */

    @ApiModelProperty("其他描述内容")
    private String content;
    /**
     * 原始数据id
     */
    @ApiModelProperty("原始数据id")
    private Integer dataId;
}
