package com.tofly.pms.working.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.pms.fegin.vo.UserVo;
import com.tofly.pms.project.service.ProjectDevWService;
import com.tofly.pms.utils.vocast.VoCast;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@ApiModel(value = "反馈信息计划表",description = "")
@TableName(value = "tf_pm_feedbackplan_w",schema = "business")
@Data
public class FeedBackPlan {

    /** id */
    @ApiModelProperty(value = "id",name = "id")
    @TableId(type = IdType.AUTO)
    private Integer id ;
    @ApiModelProperty(value = "反馈基础信息id")
    private Integer feedbackId;


    @ApiModelProperty(value = "处理方案")
    private String handlePlan;
    @ApiModelProperty(value = "描述")
    private String description;
    @ApiModelProperty(value = "解决时间")

    private String resolveDate;

    @ApiModelProperty(value = "预估工作量 小时")
    private Double planWorkload;
    @ApiModelProperty(value = "处理人")
    @VoCast(serviceClass = ProjectDevWService.class,isMulti =false,valueClass = UserVo.class)
    private String resolverPerson;
    @ApiModelProperty(value = "确认人")
    @VoCast(serviceClass = ProjectDevWService.class,isMulti =true,valueClass = UserVo.class)
    private String confirmPerson;
    @ApiModelProperty(value = "关注人")
    @VoCast(serviceClass = ProjectDevWService.class,isMulti =true,valueClass = UserVo.class)
    private String focusPerson;
    @ApiModelProperty(value = "0接收   1关闭")
    private String status;
    @ApiModelProperty(value = "是否下发任务")
    private Boolean isDispatchTask;

    /**
     * 创建人标识
     */
    @ApiModelProperty(value = "创建人标识")
    @VoCast(serviceClass = ProjectDevWService.class, isMulti = true, valueClass = UserVo.class)
    @TableField(fill = FieldFill.INSERT)
    private String createUser;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(value = "create_date", fill = FieldFill.INSERT)
    private Date createDate;
}
