package com.tofly.pms.working.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;

/**
 * 研发绩效考核统计
 * @TableName tf_pm_performance_appraisal_w
 */
@TableName(value ="TF_PM_PERFORMANCE_APPRAISAL_W",schema = "business")
@Data
public class PerformanceAppraisal implements Serializable {
    /**
     * 考核月份
     */

    private String month;

    /**
     * 姓名
     */

    private String username;

    /**
     * 用户id
     */
    private String userId;

    /**
     * 部门
     */

    private String department;

    /**
     * 项目数量
     */
    private Integer projectCount;

    /**
     * 任务总数
     */
    private Integer taskCount;

    /**
     * 任务处理数量
     */
    private Long taskDoneCount;

    /**
     * 任务驳回次数
     */
    private Long taskRejectCount;

    /**
     * 任务逾期数量
     */
    private Long taskOverdueCount;

    /**
     * 缺陷总数
     */
    private Integer bugCount;

    /**
     * 缺陷处理数量
     */
    private Long bugDoneCount;

    /**
     * 缺陷驳回次数
     */
    private Long bugRejectCount;

    /**
     * 缺陷逾期数量
     */
    private Long bugOverdueCount;

    /**
     * 预计工作量（天）
     */
    private String predictWorkTime;

    /**
     * 实际工作量（天）
     */
    private String factWorkTime;

    /**
     * 驳回率
     */
    private String rejectRate;

    /**
     * 逾期率
     */
    private String overdueRate;

    /**
     * 任务相关项目
     */
    private String taskProjectName;

    /**
     * 缺陷相关项目
     */
    private String bugProjectName;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}