package com.tofly.pms.working.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.tofly.pms.fegin.vo.UserVo;
import com.tofly.pms.project.entity.ProjectW;
import com.tofly.pms.project.service.ProjectDevWService;
import com.tofly.pms.project.service.ProjectWService;
import com.tofly.pms.utils.vocast.VoCast;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
@ApiModel(value = "计划列表",description = "")
@TableName(value = "TF_PM_PLAN_LIST_W",schema = "business")
@Data
public class PlanList {
    @ApiModelProperty(value = "id",name = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /** 项目id */
    @ApiModelProperty(value = "项目id",name = "projectId")
    @VoCast(serviceClass = ProjectWService.class,valueClass = ProjectW.class)
    private Integer projectId ;
    @ApiModelProperty(value = "计划清单名称",name = "name")
    private String name;
    @ApiModelProperty(value = "计划清单子标题",name = "subheadings")
    private String subheadings;
    @ApiModelProperty(value = "排序",name = "sortNum")
    private Integer sortNum;
    /** 创建人ID */
    @ApiModelProperty(value = "创建人ID",name = "createUser")
    @VoCast(serviceClass = ProjectDevWService.class,isMulti =false,valueClass = UserVo.class)
    @TableField(fill = FieldFill.INSERT)
    private String createUser ;
    /** 创建时间 */
    @ApiModelProperty(value = "创建时间",name = "createDate")
    @TableField(value = "create_date", fill = FieldFill.INSERT)
    private Date createDate ;
}
