package com.tofly.pms.working.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.tofly.pms.fegin.vo.UserVo;
import com.tofly.pms.file.entity.File;
import com.tofly.pms.project.service.ProjectDevWService;
import com.tofly.pms.utils.dict.Dict;
import com.tofly.pms.utils.vocast.VoCast;
import com.tofly.pms.working.service.TaskWService;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 任务日志表;  根据处理时间进行排序
 * @author : Xu'J
 * @date : 2023-12-19
 */
@Slf4j
@ApiModel(value = "任务日志表",description = "")
@TableName(value = "TF_PM_TASKLOG_W",schema = "business")
@Data
public class TasklogW implements Serializable,Cloneable{
    /** 唯一编码 */
    @ApiModelProperty(value = "唯一编码",name = "")
    @TableId(type = IdType.AUTO)
    private Integer id ;
    /** 任务id */
    @ApiModelProperty(value = "任务唯一编码",name = "")
    @VoCast(serviceClass = TaskWService.class,isMulti =true,valueClass = TaskW.class)
    private Integer taskId ;
    /** 处理时间 */
    @ApiModelProperty(value = "处理时长 单位 小时",name = "")
    private Double handleTime ;
     /** 操作类型 */
     @ApiModelProperty(value = "操作类型 0 指派 1提交 2确认 3驳回",name = "")
     private String handleType;
    /** 处理流程 */
    @ApiModelProperty(value = "处理流程",name = "")
    private String handleFlow ;
    /** 处理描述 */
    @ApiModelProperty(value = "处理描述",name = "")
    private String description ;
     /** 任务状态 */
     @ApiModelProperty(value = "原任务状态 RWZT")
     @Dict(code = "RWZT")
     private String sourceStatus;
     /** 任务状态 */
     @ApiModelProperty(value = "目标任务状态 RWZT")
     @Dict(code = "RWZT")
     private String targetStatus;
    @ApiModelProperty(value = "任务处理方式 RCLFS 或者 验证结果 RYZJG",name = "processingMode")
    @Dict(code = "RCLFS")
    private String processingMode;

    @ApiModelProperty(value = "任务的json数据",name = "jsonData")
    private String jsonData;

     /** 创建人ID */
     @ApiModelProperty(value = "创建人ID",name = "createUser")
     @VoCast(serviceClass = ProjectDevWService.class,isMulti =false,valueClass = UserVo.class)
     @TableField(fill = FieldFill.INSERT)
     private String createUser ;
     /** 创建时间 */
     @ApiModelProperty(value = "创建时间",name = "createDate")
     @TableField(value = "create_date", fill = FieldFill.INSERT)
     private Date createDate ;
     /**
      * 该值需要递增
      */
     @ApiModelProperty(value = "处理顺序",name = "handleSequence")
     private Integer handleSequence;

     @TableField(exist = false)
    private List<File> fileList;
    @TableField(exist = false)
     private TaskW task;
    @ApiModelProperty(value = "日志主要内容")
    private String content;

//    public void setProcessingModeAnnotation() {
//        try {
//            Field field = this.getClass().getDeclaredField("processingMode");
//            Dict annotation = field.getAnnotation(Dict.class);
//            InvocationHandler invocationHandler = Proxy.getInvocationHandler(annotation);
//            Field hf = invocationHandler.getClass().getDeclaredField("memberValues");
//            hf.setAccessible(true);
//            Map<String, Object> memberValues = (Map<String, Object>) hf.get(invocationHandler);
//            if ("4".equals(this.sourceStatus)) {
//                memberValues.put("code", "RYZJG");
////                memberValues.put("code", "WWWWWXXXX");
//                hf.setAccessible(false);
//            }else {
//                memberValues.put("code", "RCLFS");
////                memberValues.put("code", "WWWWWXXXX");
//                hf.setAccessible(false);
//            }
//        } catch (Exception e) {
//            log.error(e.getMessage());
//        }
//    }

}