package com.tofly.pms.working.entity;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.util.Date;

/**
* 工时月报审核
* @TableName tf_pm_workingreport_w
*/
@ApiModel(value = "工时月报审核",description = "工时月报审核")
@TableName(value = "tf_pm_workingreport_w",schema = "business")
@Data
public class Workingreport implements Serializable {

    /**
    * id
    */
    @ExcelIgnore
    @ApiModelProperty(value = "id",name = "id")
    @TableId(type = IdType.AUTO)
    private Long id;
    /**
    * 创建人
    */
    @ExcelIgnore
    @ApiModelProperty("创建人")
    @TableField(fill = FieldFill.INSERT)
    private String createUser;
    /**
    * 创建时间
    */
    @ExcelIgnore
    @ApiModelProperty("创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(value = "create_date", fill = FieldFill.INSERT)
    private Date createDate;
    /**
    * 月份
    */
    @ExcelProperty(value = "月份")
    @NotBlank(message="[月份]不能为空")
    @ApiModelProperty("月份")
    private String month;
    /**
    * 部门名称
    */
    @ExcelProperty(value = "部门名称")
    @ApiModelProperty("部门名称")
    private String deptName;
    /**
    * 部门id
    */
    @ExcelIgnore
    @ApiModelProperty("部门id")
    private String deptId;
    /**
     * 部门名称
     */
    @ExcelProperty(value = "上级部部门名称")
    @ApiModelProperty("上级部门名称")
    private String parentDeptName;
    /**
    * 员工姓名
    */
    @ExcelProperty(value = "员工姓名")
    @ApiModelProperty("员工姓名")
    private String realName;
    /**
    * 客户名称
    */
    @ExcelProperty(value = "客户名称")
    @ApiModelProperty("客户名称")
    private String customerName;
    /**
     * 客户名称
     */
    @ExcelProperty(value = "合同名称")
    @ApiModelProperty("合同名称")
    private String contractName;
    /**
    * 项目名称
    */
    @ExcelProperty(value = "项目名称")
    @ApiModelProperty("项目名称")
    private String projectName;
    /**
    * 项目id
    */
    @ExcelIgnore
    @ApiModelProperty("项目id")
    private Integer projectId;
    /**
    * 本月工作天数
    */
    @ExcelProperty(value = "本月工作天数")
    @ApiModelProperty("本月工作天数")
    private Integer workDays;
    /**
    * 本月总工时
    */
    @ExcelProperty(value = "本月总工时")
    @ApiModelProperty("本月总工时")
    private Integer workHours;
    /**
    * 本月项目工时
    */
    @ExcelProperty(value = "本月项目工时")
    @ApiModelProperty("本月项目工时")
    private Integer projectWorkHours;
    /**
    * 占比
    */
    @ExcelProperty(value = "占比")
    @ApiModelProperty("占比")
    private String proportion;
    /**
    * 审核状态
    */
    @ExcelProperty(value = "审核状态")
    @ApiModelProperty("审核状态")
    private String status;
    /**
    * 员工id
    */
    @ExcelIgnore
    @NotBlank(message="[员工id]不能为空")
    @ApiModelProperty("员工id")
    private String userId;

    @ExcelIgnore
    @TableField(exist = false)
    @ApiModelProperty(value = "工时填报不完整",name = "incomplete")
    private Boolean incomplete;
}
