package com.tofly.pms.working.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.tofly.pms.working.entity.Plan;
import com.tofly.pms.working.vo.ProjectCountVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

 /**
 * 项目计划信息表;(TF_PM_PLAN_W)表数据库访问层
 * @author : Xu'J
 * @date : 2023-12-19
 */
@Mapper
public interface PlanMapper  extends BaseMapper<Plan>{
    /** 
     * 分页查询指定行数据
     *
     * @param page 分页参数
     * @param wrapper 动态查询条件
     * @return 分页对象列表
     */
    IPage<Plan> selectByPage(IPage<Plan> page , @Param(Constants.WRAPPER) Wrapper<Plan> wrapper);

     public ProjectCountVo projectOverCount( @Param("projectId")Integer projectId);


     public Integer getMaxId();
 }