package com.tofly.pms.working.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.tofly.pms.project.vo.ProjectOverTaskCountVo;
import com.tofly.pms.working.entity.GanttData;
import com.tofly.pms.working.entity.TaskW;
import com.tofly.pms.working.vo.TaskCountVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 任务信息表;(TF_PM_TASK_W)表数据库访问层
 *
 * @author : Xu'J
 * @date : 2023-12-19
 */
@Mapper
public interface TaskWMapper extends BaseMapper<TaskW> {
    /**
     * 分页查询指定行数据
     *
     * @param page    分页参数
     * @param wrapper 动态查询条件
     * @return 分页对象列表
     */
    IPage<TaskW> selectByPage(IPage<TaskW> page, @Param(Constants.WRAPPER) Wrapper<TaskW> wrapper);


    List<TaskCountVo> taskOverProject(@Param("taskW") TaskW taskW, @Param("statusList") List<String> statusList);

    public List<String> getDistinctGroupName(@Param("taskW") TaskW taskW);

    public List<ProjectOverTaskCountVo> getProjectOverTaskCountVo(@Param("taskW") TaskW taskW,
                                                                  @Param("selfProjectId")  List<Integer> selfProjectId,
                                                                  @Param("headIdList")  List<Integer> headIdList,
                                                                  @Param("confirmIdList")  List<Integer> confirmIdList
    );

    List<TaskW> getByStatus(@Param("taskW") TaskW taskW, @Param("status") String status);

    List<GanttData> getGanttData(@Param("startDate") String startDate, @Param("endDate") String endDate,
                                 @Param("status") String status, @Param("headerId") String headerId,
                                 @Param("orgIdList") List<String> orgIdList);

    List<ProjectOverTaskCountVo> getCountMap(@Param("startDate") String startDate, @Param("endDate") String endDate,
                                              @Param("status") String status, @Param("headerId") String headerId,
                                              @Param("orgIdList") List<String> orgIdList);
}

