package com.tofly.pms.working.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.pms.base.service.BaseService;
import com.tofly.pms.working.entity.HoursW;
import com.tofly.pms.working.entity.Workingreport;
import com.tofly.pms.working.vo.*;

import java.io.IOException;
import java.util.List;
import java.util.Set;

/**
 * 工时登记表;(TF_PM_WORKINGHOURS_W)表服务接口
 * @author : Xu'J
 * @date : 2023-12-19
 */
public interface HoursWService extends BaseService<HoursW> {

    /**
     * 统计指定月份的每一天工作时长（不区分工作日和非工作日）
     *
     * @param workMonth 工作月份
     * @return 当月每一天的工作时长
     */
     List<WorkHoursVo> getWorkHoursList(String workMonth);

    Page<ProjectWorkingCountVo> projectWorkingCount(Integer projectId, String customName, String userId, String startWorkTime, String endWorkTime, Integer page, Integer size);

    Page<WorkerWorkingCountVo> workerWorkingCount(Integer projectId, String customName, String userId, String startWorkTime, String endWorkTime, Integer page, Integer size);

    void exportProject(Integer projectId, String customName, String userId, String startWorkTime, String endWorkTime) throws IOException;

    void exportWorker(Integer projectId, String customName, String userId, String startWorkTime, String endWorkTime)throws IOException;

    List<CheckHoursVo> check(String deptId, String realName, String month);

    void exportCheck(String deptId, String realName, String month) throws IOException;

    List<Workingreport> statisticsByOrgIdList(Set<String> orgIdList, String month);

   TodayTaskCompleteVo getTaskAchievement(Integer projectId);
}