package com.tofly.pms.working.service;

import com.tofly.pms.base.service.BaseService;
import com.tofly.pms.working.dto.PlanDispatchDto;
import com.tofly.pms.working.entity.Plan;
import com.tofly.pms.working.vo.ProjectCountVo;
import org.springframework.web.bind.annotation.RequestBody;

import java.io.IOException;

/**
 * 项目计划信息表;(TF_PM_PLAN_W)表服务接口
 * @author : Xu'J
 * @date : 2023-12-19
 */
public interface PlanService  extends BaseService<Plan> {
 /**
  * 统计工作量  以及任务数量
  * @param projectId
  * @return
  */
 public ProjectCountVo projectOverCount(Integer projectId);


 public Integer getMaxId();

 /**'
  * 派发任务
  * @param planDispatchDto
  * @return
  */
Boolean dispatchPlan(@RequestBody PlanDispatchDto planDispatchDto);


 public boolean removeChildByIds(String ids);

 String getFullPath(Integer id);

    void export(Integer projectId, Integer listId) throws IOException;
}