package com.tofly.pms.working.service;

import com.tofly.pms.base.service.BaseService;
import com.tofly.pms.project.vo.ProjectOverTaskCountVo;
import com.tofly.pms.project.vo.ProjectVo;
import com.tofly.pms.working.dto.TaskHandleBatchDto;
import com.tofly.pms.working.dto.TaskHandleDto;
import com.tofly.pms.working.entity.GanttData;
import com.tofly.pms.working.entity.TaskW;

import java.util.List;

/**
 * 任务信息表;(TF_PM_TASK_W)表服务接口
 * @author : Xu'J
 * @date : 2023-12-19
 */
public interface TaskWService  extends BaseService<TaskW> {

 public List<ProjectVo> taskOverProject(TaskW taskW,List<String> statusList);
 public List<ProjectVo> taskOverProject2(TaskW taskW,String status);

 public List<String> getDistinctGroupName(TaskW taskW);

 public List<ProjectOverTaskCountVo> getProjectOverTaskCountVo(TaskW taskW);

 /**
  * 任务处理
  * @param taskHandleDto
  */
 public  void taskHandle(TaskHandleDto taskHandleDto);

 /**
  * 批量任务处理
  * @param taskHandleBatchDto
  */
 public  void taskHandleBatch(TaskHandleBatchDto taskHandleBatchDto);


 void handleSingleTask(TaskW taskW);

 List<GanttData> getGanttData(GanttData data);

 List<ProjectOverTaskCountVo> countGanttData(GanttData data);

    void updateTaskInfo(TaskW taskW);
}