package com.tofly.pms.working.service.impl;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.lang.Assert;
import cn.hutool.core.util.IdUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.pms.working.entity.Holidays;
import com.tofly.pms.working.mapper.HolidaysMapper;
import com.tofly.pms.working.service.HolidaysService;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author sheldon
 * @Description
 * @create 2024-04-15 9:18
 */
@Service
public class HolidaysServiceImpl extends ServiceImpl<HolidaysMapper, Holidays>
        implements HolidaysService {
    @Override
    public Holidays queryById(Integer id) {
        return null;
    }

    @Override
    public boolean save(Holidays entity) {
        List<Date> holidayDateList = entity.getHolidayDateList();
        if (CollectionUtil.isNotEmpty(holidayDateList)) {
            List<Holidays> bathList = holidayDateList.stream().map(date -> {
                Holidays holidays = new Holidays();
                long id = IdUtil.getSnowflake().nextId();
                holidays.setId(String.valueOf(id));
                holidays.setHolidayDate(date);
                holidays.setHolidayType(entity.getHolidayType());
                holidays.setHolidayName(entity.getHolidayName());
                return holidays;
            }).collect(Collectors.toList());
            return super.saveBatch(bathList);
        } else {
            Assert.notNull(entity.getHolidayDate(), "请选择节假日日期");
            long id = IdUtil.getSnowflake().nextId();
            entity.setId(String.valueOf(id));
            return super.save(entity);
        }
    }

    @Override
    public List<Date> getHolidays(Date startDate, Date endDate, int type) {
        return baseMapper.getHolidays(startDate, endDate, type);
    }
}
