package com.tofly.pms.working.service.impl;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.pms.utils.UserTokenUtil;
import com.tofly.pms.working.entity.TasklogW;
import com.tofly.pms.working.mapper.TasklogWMapper;
import com.tofly.pms.working.service.TasklogWService;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * 任务日志表;(TF_PM_TASKLOG_W)表服务实现类
 *
 * @author : Xu'J
 * @date : 2023-12-19
 */
@Service
public class TasklogWServiceImpl extends ServiceImpl<TasklogWMapper, TasklogW> implements TasklogWService {

    @Override
    public TasklogW queryById(Integer id) {
        return baseMapper.selectById(id);
    }


    @Override
    public Integer getMaxSequenceAddOne(Integer taskId) {
        return baseMapper.getMaxSequenceAddOne(taskId);
    }

    @Override
    public List<Integer> getTaskIdList(Boolean isAll) {
        return baseMapper.getTaskIdList(isAll);
    }

    @Override
    public List<TasklogW> selectByMaxIdForEachTaskId(List<Integer> taskIds) {
        return baseMapper.selectByMaxIdForEachTaskId(taskIds);
    }

    public boolean save(TasklogW tasklogW) {
        Assert.notNull(tasklogW, "任务日志不能为空");
        Assert.notNull(tasklogW.getTaskId(), "任务id不能为空");
        Assert.notBlank(tasklogW.getSourceStatus(), "任务状态不能为空");
        Assert.notBlank(tasklogW.getJsonData(),"任务内容不能为空");
        tasklogW.setCreateDate(new Date());
        tasklogW.setCreateUser(UserTokenUtil.getTokenUserID());
        return super.save(tasklogW);
    }

    public boolean updateById(TasklogW tasklogW) {
        throw new RuntimeException("日志不允许修改");
    }

    public boolean removeById(Integer id) {
        throw new RuntimeException("日志不允许删除");
    }
}