package com.tofly.pms.working.vo;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.pms.fegin.vo.UserVo;
import com.tofly.pms.file.entity.File;
import com.tofly.pms.file.service.FileService;
import com.tofly.pms.project.entity.ProjectW;
import com.tofly.pms.project.service.ProjectDevWService;
import com.tofly.pms.project.service.ProjectWService;
import com.tofly.pms.testmanage.entity.SystemItem;
import com.tofly.pms.testmanage.entity.TestSystem;
import com.tofly.pms.testmanage.service.SystemItemService;
import com.tofly.pms.testmanage.service.TestSystemService;
import com.tofly.pms.utils.dict.Dict;
import com.tofly.pms.utils.vocast.VoCast;
import com.tofly.pms.working.entity.FeedBackPlan;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;
@Data
public class FeedBackWithPlanVo implements Serializable {

    /** id */
    @ApiModelProperty(value = "id",name = "id")
    @TableId(type = IdType.AUTO)
    private Integer id ;

    @ApiModelProperty(value = "图片")
    @VoCast(serviceClass = FileService.class, isMulti = true, valueClass = File.class)
    private String fileUrl;

    @ApiModelProperty(value = "意见类别 VIEWTYPE")
    @Dict(code = "VIEWTYPE")
    private String viewType;

    @ApiModelProperty(value = "反馈紧急程度 VIEWURGENCY")
    @Dict(code = "VIEWURGENCY")
    private String urgency;

    @ApiModelProperty(value = "意见类型 VIEWTYLE")
    @Dict(code = "VIEWTYLE")
    private String viewTyle;
    @ApiModelProperty(value = "项目")
    @VoCast(serviceClass = ProjectWService.class,valueClass = ProjectW.class)
    private Integer projectId;
    @VoCast(serviceClass = TestSystemService.class,valueClass = TestSystem.class)
    @ApiModelProperty(value = "系统")
    private Integer systemId;
    @ApiModelProperty(value = "模型")
    @VoCast(serviceClass = SystemItemService.class,valueClass = SystemItem.class)
    private Integer modelId;
    @ApiModelProperty(value = "系统")
    private String systemName;
    @ApiModelProperty(value = "模型")
    private String modelName;
    @ApiModelProperty(value = "标题")
    private String title;
    @ApiModelProperty(value = "描述")
    private String description;

    @ApiModelProperty(value = "反馈部门")
    private String dept;

    @ApiModelProperty(value = "反馈人员")
    private String  feedUser;
    @ApiModelProperty(value = "提出时间")
    private String feedTime;
    @ApiModelProperty(value = "处理方案")
    private String handlePlan;
    @ApiModelProperty(value = "处理描述")
    private String resolverDescription;
    @ApiModelProperty(value = "解决时间")
    private String resolveDate;
    @ApiModelProperty(value = "处理人")
    @VoCast(serviceClass = ProjectDevWService.class,isMulti =true,valueClass = UserVo.class)
    private String resolverPerson;

    /** 创建人标识 */
    @ApiModelProperty(value = "创建人标识")
    @VoCast(serviceClass = ProjectDevWService.class,isMulti =true,valueClass = UserVo.class)
    @TableField(fill = FieldFill.INSERT)
    private String createUser ;
    /** 创建时间 */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(value = "create_date", fill = FieldFill.INSERT)
    private Date createDate ;
    @ApiModelProperty(value = "意见关联的总任务数")
    private Long totalTask;
    @ApiModelProperty(value = "意见关联的完成的任务数")
    private Long completedTask;
    @ApiModelProperty(value = "对应状态的数量")
    private Long count;

    private FeedBackPlan feedBackPlan;
}
