package com.tofly.pms.working.vo;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.tofly.pms.fegin.UserClient;
import com.tofly.pms.fegin.vo.UserVo;
import com.tofly.pms.utils.vocast.VoCast;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author sheldon
 * @Description
 * @create 2024-04-12 11:07
 */
@Data
public class WorkerWorkingCountVo {
    @ExcelProperty(value = "项目名称", index = 0)
    @ApiModelProperty(value = "项目名称")
    private String name;
    @ExcelProperty(value = "客户名称", index = 1)
    @ApiModelProperty(value = "客户名称")
    private String customName;
    @ExcelProperty(value = "合同名称", index = 2)
    @ApiModelProperty(value = "合同名称")
    private String contractName;
    @ExcelProperty(value = "部门名称", index = 3)
    @ApiModelProperty(value = "部门名称")
    private String orgName;
    @ExcelIgnore
    @ApiModelProperty(value = "员工")
    @VoCast(serviceClass = UserClient.class, isMulti = false, valueClass = UserVo.class)
    private String userId;
    @ExcelProperty(value = "员工名称", index = 4)
    @ApiModelProperty(value = "员工名称")
    private String username;
    @ExcelProperty(value = "合计笔数", index = 5)
    @ApiModelProperty(value = "合计笔数")
    private Integer count;
    @ExcelProperty(value = "合计小时", index = 6)
    @ApiModelProperty(value = "合计小时")
    private Integer workingHours;
    @ExcelProperty(value = "合计人天", index = 7)
    @ApiModelProperty(value = "合计人天")
    private Double workingDays;
    @ExcelProperty(value = "合计人月", index = 8)
    @ApiModelProperty(value = "合计人月")
    private Double workingMonths;

}
